<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Location extends Admin_Controller
{

    public function __construct()
    {
        parent::__construct();
        $this->load->model('Location_Model');
        $this->load->library('form_validation');
    }

    public function currentlocation($id = NULL)
    {
        $data['title'] = lang('salesperson') . ' ' . lang('current_location');
        $data['assign_user'] = $this->Location_Model->allowed_user('161');

        $data['salespersons'] = $this->Location_Model->get_all_salespersons();
        $data['subview'] = $this->load->view('admin/location/currentlocation', $data, TRUE);
        $this->load->view('admin/_layout_main', $data); //page load
    }

    public function getLatLong()
    {
        $salesperson_id=$this->input->post('salesperson_id');
        if ($rows = $this->Location_Model->getLatLongByID($salesperson_id)) 
        {             
            $today = date('Y-m-d H:i:s');
            $now = strtotime(date('Y-m-d H:i:s',strtotime($today))); 
            $your_date = strtotime(date('Y-m-d H:i:s',strtotime($rows['date'])));
            $datediff = $now - $your_date;
            if($datediff  > (60 * 60 * 24))
            {
                $this->Location_Model->updateStatus($salesperson_id);
                $new_row = $this->Location_Model->getLatLongByID($salesperson_id);
            }
            else
            {
                $new_row = $rows;
            }
            
            $data = json_encode($new_row);
        } else {

            $data = json_encode(NULL);

        }
        echo $data;
        exit();
    }

    public function tracksalesperson($id = NULL)
    {
        $data['title'] = lang('track') . ' ' . lang('salesmanager');
        $data['assign_user'] = $this->Location_Model->allowed_user('161');

        $data['salespersons'] = $this->Location_Model->get_all_salespersons();
        $data['subview'] = $this->load->view('admin/location/tracksalesperson', $data, TRUE);
        $this->load->view('admin/_layout_main', $data); //page load
    }

    function getXmldatabetweendate($salesman_id,$from_date,$to_date)
    {
        $from_date=date('Y-m-d',strtotime($from_date)).' 00:00:00';
        $to_date=date('Y-m-d',strtotime($to_date)).' 23:59:59';
        $this->load->library('datatables');
            $this->datatables
            ->select("id,start_time,end_time,start_address,end_address,CONCAT_WS(' ', distance, 'Km')", FALSE)
            ->from('tbl_salesman_locations')
            ->where('salesman_id',$salesman_id)
            ->where('end_time >=',$from_date)
            ->where('end_time <=',$to_date);
            $this->datatables->unset_column('id');
            $this->datatables->add_column('actions', "<button class='btn btn-primary btn-default' type='submit' onclick='window.open(\" displayMap/$1\",\"#myModalEdit\",\"location=1,status=1,scrollbars=1,  width=1400,height=900\")'>Show</button>", 'id');
            echo $this->datatables->generate();
        exit();
    }
      
    function displayMap($id=NULL)
    {
        $temp =$this->getXmldata($id);
        $data['xml_data']= $temp;
        $this->load->view('admin/location/popupview', $data);
    }

    function getXmldata($id = NULL)
    {
        $this->load->helper('xml');
        if ($rows = $this->Location_Model->getXmldata($id)) {
            $data1['ob']= simplexml_load_string($rows['route_info']);
            $data1['start_address']=$rows['start_address'];
            $data1['end_address']=$rows['end_address'];
            $data1['fullname']=$rows['fullname'];
            $data1['start_time']=$rows['start_time'];
            $data1['end_time']=$rows['end_time'];
            $data1['distance']=$rows['distance'];
            $data = json_encode($data1);
        } else {
            $data = json_encode(NULL);
        }
        return $data;
    }
}









