<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of admistrator
 *
 * @author pc mart ltd
 */
class Quotations extends Admin_Controller
{

    public function __construct()
    {
        parent::__construct();
        $this->load->model('quotations_model');
        $this->load->library('form_validation');
        $this->load->model('items_model');
        $this->load->model('rest_api_models/CalculationConfig_Model'); 
        $this->load->model('rest_api_models/KWSolarRateCard_Model');
    }

    public function indexold($action = NULL, $id = NULL)
    {
        $data['title'] = lang('quotations');
        $data['page'] = lang('quotations');
        $data['sub_active'] = lang('quotations');
        if ($action == 'delete_quotations') {
            $this->quotations_model->_table_name = 'tbl_quotations';
            $this->quotations_model->_primary_key = 'quotations_id';
            $this->quotations_model->delete($id);
            $type = 'success';
            $message = lang('delete_quotation');
            set_message($type, $message);
            redirect('admin/quotations/');
        } else {

            $sub_view = 'all_quotations';
            //$sub_view = 'all_quotations';
            $data['active'] = 1;
        }
        $this->quotations_model->_table_name = 'tbl_quotations';
        $this->quotations_model->_order_by = 'quotations_id';
        $data['all_quatations'] = $this->quotations_model->get();

        $data['subview'] = $this->load->view('admin/quotations/' . $sub_view, $data, TRUE);
        $this->load->view('admin/_layout_main', $data);
    }

    public function quotationsList()
    {
        if ($this->input->is_ajax_request()) {
            $this->load->model('datatables');
            $this->datatables->table = 'tbl_quotations';
            $this->datatables->column_order = array('quotations_date', 'quotations_amount');
            $this->datatables->column_search = array('quotations_date', 'quotations_amount');
            $this->datatables->order = array('quotations_id' => 'desc');

            // get all invoice
            $fetch_data = make_datatables();

            $data = array();

            foreach ($fetch_data as $_key => $v_quatations) {

                $action = null;
                $user_info = $this->quotations_model->check_by(array('user_id' => $v_quatations->user_id), 'tbl_users');
                if (!empty($user_info)) {
                    if ($user_info->role_id == 1) {
                        $user = '(' . lang('admin') . ')';
                    } elseif ($user_info->role_id == 3) {
                        $user = '(' . lang('staff') . ')';
                    } else {
                        $user = '(' . lang('client') . ')';
                    }
                } else {
                    $user = ' ';
                }

                $sub_array = array();

                $sub_array[] = '<a class="text-info" href="' . base_url() . 'admin/quotations/quotations_details/' . $v_quatations->quotations_id . '">' . $v_quatations->quotations_form_title . '</a>';

                $sub_array[] = $v_quatations->name;
                $sub_array[] = strftime(config_item('date_format'), strtotime($v_quatations->quotations_date));
                $amount = null;
                if (!empty($v_quatations->quotations_amount)) {
                    $amount = display_money($v_quatations->quotations_amount, client_currency($v_quatations->client_id));
                }
                $sub_array[] = $amount;
                if ($v_quatations->quotations_status == 'completed') {
                    $quotations_status = '<span class="label label-success">' . lang('completed') . '</span>';
                } else {
                    $quotations_status = '<span class="label label-danger">' . lang('pending') . '</span>';
                };
                $sub_array[] = $quotations_status;

                $sub_array[] = (!empty($user_info->username) ? $user_info->username : '-') . ' ' . $user;

                $action .= btn_view('admin/quotations/quotations_details/' . $v_quatations->quotations_id) . ' ';
                $action .= ajax_anchor(base_url("admin/quotations/index/delete_quotations/$v_quatations->quotations_id"), "<i class='btn btn-xs btn-danger fa fa-trash-o'></i>", array("class" => "", "title" => lang('delete'), "data-fade-out-on-success" => "#table_" . $_key)) . ' ';

                $sub_array[] = $action;
                $data[] = $sub_array;
            }

            render_table($data);
        } else {
            redirect('admin/dashboard');
        }
    }

    public function quotations_form($action = NULL, $id = NULL)
    {
        $data['title'] = lang('quotations');
        $data['page'] = lang('quotations');
        $data['quotationforms_info'] = $this->quotations_model->check_by(array('quotationforms_id' => $id), 'tbl_quotationforms');
        if ($action == 'edit_quotations_form') {
            $data['sub_active'] = lang('quotations_form');
            $form_data = json_decode($data['quotationforms_info']->quotationforms_code, true);

            $data['formbuilder_data'] = $form_data['fields'];

            $data['quotationforms_code'] = json_encode($form_data['fields']);
            $sub_view = 'quotations_form_details';
            $data['active'] = 2;
        } elseif ($action == 'delete_quotations_form') {
            // save into activities
            $activities = array(
                'user' => $this->session->userdata('user_id'),
                'module' => 'quotations',
                'module_field_id' => $id,
                'activity' => ('activity_delete_quotations_form'),
                'icon' => 'fa-coffee',
                'value1' => $data['quotationforms_info']->quotationforms_title,
            );
            // Update into tbl_project
            $this->quotations_model->_table_name = "tbl_activities"; //table name
            $this->quotations_model->_primary_key = "activities_id";
            $this->quotations_model->save($activities);

            $this->quotations_model->_table_name = 'tbl_quotationforms';
            $this->quotations_model->_primary_key = 'quotationforms_id';
            $this->quotations_model->delete($id);
            $type = 'success';
            $message = lang('delete_quotation_form');
            set_message($type, $message);
            if (empty($_SERVER['HTTP_REFERER'])) {
                redirect('admin/quotations_form');
            } else {
                redirect($_SERVER['HTTP_REFERER']);
            }
        } else {
            $data['sub_active'] = lang('quotations_form');
            $sub_view = 'quotations_form';
            //$sub_view = 'all_quotations';
            $data['active'] = 1;
        }
        $this->quotations_model->_table_name = 'tbl_quotationforms';
        $this->quotations_model->_order_by = 'quotationforms_id';
        $data['all_quatations'] = $this->quotations_model->get();

        $data['subview'] = $this->load->view('admin/quotations/' . $sub_view, $data, TRUE);
        $this->load->view('admin/_layout_main', $data);
    }

    public function quotationsformList()
    {
        if ($this->input->is_ajax_request()) {
            $this->load->model('datatables');
            $this->datatables->table = 'tbl_quotationforms';
            $this->datatables->column_order = array('quotationforms_title', 'quotationforms_date_created');
            $this->datatables->column_search = array('quotationforms_title', 'quotationforms_date_created');
            $this->datatables->order = array('quotationforms_id' => 'desc');

            // get all invoice
            $fetch_data = make_datatables();

            $data = array();

            foreach ($fetch_data as $_key => $v_quatations) {

                $action = null;
                $sub_array = array();

                $sub_array[] = '<a class="text-info" href="' . base_url() . 'admin/quotations/quotations_form_details/' . $v_quatations->quotationforms_id . '">' . $v_quatations->quotationforms_title . '</a>';

                $sub_array[] = fullname($v_quatations->quotations_created_by_id);
                $sub_array[] = strftime(config_item('date_format'), strtotime($v_quatations->quotationforms_date_created));
                if ($v_quatations->quotationforms_status == 'enabled') {
                    $quotationforms_status = '<span class="label label-success"> ' . lang('enabled') . '</span>';
                } else {
                    $quotationforms_status = '<span class="label label-danger">' . lang('disabled') . '</span>';
                };
                $sub_array[] = $quotationforms_status;

                $action .= btn_view('admin/quotations/quotations_form/edit_quotations_form/' . $v_quatations->quotationforms_id) . ' ';
                $action .= ajax_anchor(base_url("admin/quotations/quotations_form/delete_quotations_form/$v_quatations->quotationforms_id"), "<i class='btn btn-xs btn-danger fa fa-trash-o'></i>", array("class" => "", "title" => lang('delete'), "data-fade-out-on-success" => "#table_" . $_key)) . ' ';

                $sub_array[] = $action;
                $data[] = $sub_array;
            }

            render_table($data);
        } else {
            redirect('admin/dashboard');
        }
    }

    public function quotations_details($quotations_id)
    {
        $data['title'] = 'View  Quatations Form';
        $data['page'] = lang('quotations');
        $data['sub_active'] = lang('quotations');
        $data['quotations_info'] = $this->quotations_model->check_by(array('quotations_id' => $quotations_id), 'tbl_quotations');
        $this->quotations_model->_table_name = 'tbl_quotation_details';
        $this->quotations_model->_order_by = 'quotations_id';
        $data['quotation_details'] = $this->quotations_model->get_by(array('quotations_id' => $quotations_id), FALSE);
        $data['subview'] = $this->load->view('admin/quotations/quotation_details', $data, TRUE);
        $this->load->view('admin/_layout_main', $data);
    }

    public function quotations_details_pdf($quotations_id)
    {
        $data['title'] = 'View  Quatations Form';
        $data['page'] = lang('quotations');
        $data['sub_active'] = lang('quotations');
        $data['quotations_info'] = $this->quotations_model->check_by(array('quotations_id' => $quotations_id), 'tbl_quotations');
        $this->quotations_model->_table_name = 'tbl_quotation_details';
        $this->quotations_model->_order_by = 'quotations_id';
        $data['quotation_details'] = $this->quotations_model->get_by(array('quotations_id' => $quotations_id), FALSE);
//        $data['subview'] = $this->load->view('admin/quotations/quotations_details_pdf', $data,true);
//        $this->load->view('admin/_layout_main', $data);

        $this->load->helper('dompdf');
        $viewfile = $this->load->view('admin/quotations/quotations_details_pdf', $data, TRUE);
        pdf_create($viewfile, slug_it($data['quotations_info']->quotations_form_title));
    }

    public function set_price($quotations_id)
    {
        $data['quotations_id'] = $quotations_id;
        $data['quotations_info'] = $this->quotations_model->check_by(array('quotations_id' => $quotations_id), 'tbl_quotations');
        $data['subview'] = $this->load->view('admin/quotations/set_price', $data, FALSE);
        $this->load->view('admin/_layout_modal', $data);
    }

    public function set_price_quotations($id)
    {
        $data = $this->quotations_model->array_from_post(array('quotations_amount', 'notes'));
        $qtation_info = $this->quotations_model->check_by(array('quotations_id' => $id), 'tbl_quotations');
        $client_info = $this->quotations_model->check_by(array('client_id' => $qtation_info->client_id), 'tbl_client');

        $send_mail = $this->input->post('send_email', TRUE);
        if ($send_mail == 'on') {
            $email_template = email_templates(array('email_group' => 'quotations_form'), $qtation_info->client_id);
            
            $message = $email_template->template_body;
            $subject = $email_template->subject;
            $client_name = str_replace("{CLIENT}", $client_info->name, $message);

            $Date = str_replace("{DATE}", date('Y-m-d'), $client_name);
            $Currency = str_replace("{CURRENCY}", client_currency($qtation_info->client_id), $Date);
            $Amount = str_replace("{AMOUNT}", $this->input->post('quotations_amount', true), $Currency);
            $Notes = str_replace("{NOTES}", $this->input->post('notes', true), $Amount);
            $link = str_replace("{QUOTATION LINK}", base_url() . 'client/quotations/quotations_details/' . $id, $Notes);
            $message = str_replace("{SITE_NAME}", config_item('company_name'), $link);

            $sdata['message'] = $message;
            $message = $this->load->view('email_template', $sdata, TRUE);


            $address = $client_info->email;
            $params['recipient'] = $address;
            $params['subject'] = '[ ' . config_item('company_name') . ' ]' . ' ' . $subject;
            $params['message'] = $message;
            $params['resourceed_file'] = '';
            $this->quotations_model->send_email($params);
        }
        if (!empty($client_info->primary_contact)) {
            $notifyUser = array($client_info->primary_contact);
        } else {
            $user_info = $this->quotations_model->check_by(array('company' => $client_info->client_id), 'tbl_account_details');
            if (!empty($user_info)) {
                $notifyUser = array($user_info->user_id);
            }
        }
        if (!empty($notifyUser)) {
            foreach ($notifyUser as $v_user) {
                if ($v_user != $this->session->userdata('user_id')) {
                    add_notification(array(
                        'to_user_id' => $v_user,
                        'icon' => 'paste',
                        'description' => 'not_set_quotations_price',
                        'link' => 'client/quotations/quotations_details/' . $id,
                        'value' => $qtation_info->quotations_form_title . ' ' . lang('amount') . ' ' . display_money($this->input->post('quotations_amount', true), client_currency($qtation_info->client_id)),
                    ));
                }
            }
            show_notification($notifyUser);
        }

        // save into activities
        $activities = array(
            'user' => $this->session->userdata('user_id'),
            'module' => 'quotations',
            'module_field_id' => $id,
            'activity' => ('activity_set_quotations_price'),
            'icon' => 'fa-coffee',
            'value1' => $qtation_info->quotations_form_title,
            'value2' => $client_info->name . '(' . display_money($this->input->post('quotations_amount', true), client_currency($qtation_info->client_id)) . ')',
        );
        // Update into tbl_project
        $this->quotations_model->_table_name = "tbl_activities"; //table name
        $this->quotations_model->_primary_key = "activities_id";
        $this->quotations_model->save($activities);

        $data['reviewer_id'] = $this->session->userdata('user_id');
        $data['reviewed_date'] = date('Y-m-d H:i:s');
        $data['quotations_status'] = 'completed';

        $this->quotations_model->_table_name = 'tbl_quotations';
        $this->quotations_model->_primary_key = 'quotations_id';
        $this->quotations_model->save($data, $id);
        $type = 'success';
        $message = lang('save_quotation_form');
        set_message($type, $message);
        if (empty($_SERVER['HTTP_REFERER'])) {
            redirect('admin/quotations_form');
        } else {
            redirect($_SERVER['HTTP_REFERER']);
        }
    }

    public function quotations_form_details($id)
    {
        $data['title'] = 'View  Quatations Form';
        $data['page'] = lang('quotations');
        $data['sub_active'] = lang('quotations_form');
        $data['quotationforms_info'] = $this->quotations_model->check_by(array('quotationforms_id' => $id), 'tbl_quotationforms');

        $form_data = json_decode($data['quotationforms_info']->quotationforms_code, true);

        $data['formbuilder_data'] = $form_data['fields'];

        $data['quotationforms_code'] = json_encode($form_data['fields']);

        $data['subview'] = $this->load->view('admin/quotations/view_quotations_form', $data, TRUE);
        $this->load->view('admin/_layout_main', $data);
    }

    public function quotations_form_details_pdf($id)
    {
        $data['title'] = 'View  Quatations Form';
        $data['quotationforms_info'] = $this->quotations_model->check_by(array('quotationforms_id' => $id), 'tbl_quotationforms');
        $form_data = json_decode($data['quotationforms_info']->quotationforms_code, true);
        $data['formbuilder_data'] = $form_data['fields'];
        $data['quotationforms_code'] = json_encode($form_data['fields']);
        $this->load->helper('dompdf');
        $viewfile = $this->load->view('admin/quotations/quotations_form_details_pdf', $data, TRUE);
        pdf_create($viewfile, slug_it($data['quotationforms_info']->quotationforms_title));
    }


    public function add_form($id = NULL)
    {
        $data['quotationforms_title'] = $this->input->post('quotationforms_title', TRUE);
        $data['quotationforms_code'] = $this->input->post('quotationforms_code', TRUE);
        if (!empty($id)) {
            $data['quotationforms_status'] = $this->input->post('quotationforms_status', TRUE);
        }
        $data['quotations_created_by_id'] = $this->session->userdata('user_id');

        $this->quotations_model->_table_name = 'tbl_quotationforms';
        $this->quotations_model->_primary_key = 'quotationforms_id';
        $this->quotations_model->save($data, $id);
        if (!empty($id)) {
            $action = ('activity_update_quotation_form');
        } else {
            $action = ('activity_save_quotation_form');
        }
        // save into activities
        $activities = array(
            'user' => $this->session->userdata('user_id'),
            'module' => 'quotations',
            'module_field_id' => $id,
            'activity' => $action,
            'icon' => 'fa-coffee',
            'value1' => $data['quotationforms_title'],
        );
        // Update into tbl_project
        $this->quotations_model->_table_name = "tbl_activities"; //table name
        $this->quotations_model->_primary_key = "activities_id";
        $this->quotations_model->save($activities);

        $type = 'success';
        $message = lang('save_quotation_form');
        set_message($type, $message);
        if (empty($_SERVER['HTTP_REFERER'])) {
            redirect('admin/quotations_form');
        } else {
            redirect($_SERVER['HTTP_REFERER']);
        }
    }


    // added code for generate quotation
    public function index($id = NULL) 
    {
        $data['title'] = lang('all_leads');
        if (!empty($id)) 
        {
            $data['active'] = 2;
            $edited = can_action('163', 'edited');
            if (!empty($edited)) 
            {
                $data['leads_info'] = $this->items_model->check_by(array('leads_id' => $id), 'tbl_leads');
                $data['districts'] = $this->items_model->getAllDistrictsByStateId($data['leads_info']->state_id);
                $data['subcategories'] = $this->items_model->getAllSubcategoriesByCatId($data['leads_info']->lead_category_id);
                $data['panel_manuf'] = $this->items_model->getManufacturer('Panel');
                $data['inverter_manuf'] = $this->items_model->getManufacturer('Inverter');
                $data['cal_config'] = $this->CalculationConfig_Model->getLatestCalConfiguration();
                // calculate requiredkw
                $unit_type = $data['leads_info']->unit_type;
                $units = $data['leads_info']->units;
                if($unit_type == 'Monthly') 
                {
                    $no_of_months = $data['leads_info']->no_of_months;
                    $days = $no_of_months * 30;
                    $requiredkW = number_format((float)(($units/$days)/$data['cal_config']->required_kw_factor), 2, '.', '');
                }                
                else if($unit_type == 'Yearly')
                {
                    $requiredkW = number_format((float)(($units/365)/$data['cal_config']->required_kw_factor), 2, '.', '');
                }

                if($requiredkW)
                {
                    $solar_rate = $this->KWSolarRateCard_Model->get_all_KWSolarRateCard($requiredkW);
                    for($i = 0 ; $i < count($solar_rate); $i++)
                    {
                        if($i==0)
                        {
                            if($requiredkW <= $solar_rate[$i]['lower_kw'])
                            {
                                $requiredkW = $solar_rate[$i]['lower_kw'];
                                $solar_rate_info = $solar_rate[$i];
                                break;
                            }
                            else if($requiredkW > $solar_rate[$i]['lower_kw'] && $requiredkW <= $solar_rate[$i]['higher_kw'])
                            {
                                $solar_rate_info = $solar_rate[$i];
                                break;
                            }
                        }
                        else if($i==count($solar_rate)-1)
                        {
                            if($requiredkW >= $solar_rate[$i]['lower_kw'])
                            {
                                $solar_rate_info = $solar_rate[$i];
                                break;
                            }
                        }
                        else
                        {
                            if($requiredkW >= $solar_rate[$i]['lower_kw'] && $requiredkW <= $solar_rate[$i]['higher_kw'])
                            {
                                $solar_rate_info = $solar_rate[$i];
                                break;
                            }
                        }
                    }
                    $data['required_kw'] = $requiredkW;
                    $data['solar_rate_info'] = $solar_rate_info;
                }
            }
        } else {
            $data['active'] = 1;
        }
        $data['assign_user'] = $this->items_model->allowed_user('163');
        if (!empty($search)) {
            $data['all_leads'] = $by_status;
        } else {
            $data['all_leads'] = $this->items_model->get_permission('tbl_leads');
        }

        $data['states'] = $this->items_model->get_all_states();
        $data['categories'] = $this->items_model->get_all_lead_categories();
        //$data['products'] = $this->items_model->get_all_products();

        $data['subview'] = $this->load->view('admin/quotations/quotation_list', $data, TRUE);
        $this->load->view('admin/_layout_main', $data); //page load
    }

    public function leadList($filterBy = null, $search_by = null)
    {
        if ($this->input->is_ajax_request()) {
            $this->load->model('datatables');
            $this->datatables->table = 'tbl_leads';
            $custom_field = custom_form_table_search(5);
            $main_column = array('CONCAT(first_name," ",middle_name," ",last_name) as lead_name', 'mobile', 'city', 'address','lead_status');
            $action_array = array('leads_id');
            $result = array_merge($main_column, $custom_field, $action_array);
            $this->datatables->column_order = $result;
            $this->datatables->column_search = $result;
            $this->datatables->order = array('leads_id' => 'ASC');

            $status = array('Request For Quotation','Quotation Sent','Request For Regenerate Quotation','Quotation Approved');
            $where_in = array('lead_status',$status);            

            $fetch_data = $this->datatables->get_leads(NULL, NULL, $where,NULL,$where_in);

            $data = array();

            $edited = can_action('163', 'edited');
            $deleted = can_action('163', 'deleted');
            foreach ($fetch_data as $_key => $v_leads) {
                $action = null;
                if (!empty($v_leads)) {
                    $sub_array = array();
                    if (!empty($deleted)) {
                        $sub_array[] = '<div class="checkbox c-checkbox" ><label class="needsclick"> <input name="ids[]" value="' . $v_leads->leads_id . '" type="checkbox"><span class="fa fa-check"></span></label></div>';
                    }
                    $name = null;
                    /*$name .= '<a class="text-info" href="' . base_url() . 'admin/leads/leads_details/' . $v_leads->leads_id . '">' . $v_leads->first_name . ' ' .$v_leads->middle_name . ' ' . $v_leads->last_name . '</a>';*/
                    $name .= $v_leads->first_name . ' ' .$v_leads->middle_name . ' ' . $v_leads->last_name;
                    $sub_array[] = $name;
                    $sub_array[] = $v_leads->mobile;
                    $sub_array[] = $v_leads->city;
                    $sub_array[] = $v_leads->address;
                    $sub_array[] = $v_leads->lead_status;

                    $quotation_list = $this->quotations_model->getQuotationsById($v_leads->leads_id);

                    if (!empty($edited) && $v_leads->lead_status !='Quotation Approved') {
                        $action .= btn_edit('admin/quotations/index/' . $v_leads->leads_id) . ' ';
                    }
                    if (!empty($deleted)) {
                        $action .= ajax_anchor(base_url("admin/quotations/delete_leads/$v_leads->leads_id"), "<i class='btn btn-xs btn-danger fa fa-trash-o'></i>", array("class" => "", "title" => lang('delete'), "data-fade-out-on-success" => "#table_" . $_key)) . ' ';
                    }
                    if(!empty($quotation_list))
                    {
                        $action .= btn_view('admin/quotations/quotationlist/' . $v_leads->leads_id) . ' ';
                    }
                    $sub_array[] = $action;
                    $data[] = $sub_array;
                }

            }
            render_table($data, $where, $where_in, $or_where);
        } else {
            redirect('admin/dashboard');
        }
    }

    public function download_attachment($id,$type)
    {
        $this->items_model->_table_name = "tbl_leads";
        $leads_info = $this->items_model->get_by(array('leads_id' => $id), TRUE);
        if($type=='bill')
        {
            $file = $leads_info->attachment;
        }
        if (file_exists($file)) {
            $this->load->helper('download');
            force_download($file, NULL);
            exit();
        }
        $this->session->set_flashdata('error', "File not exist");
        redirect($_SERVER["HTTP_REFERER"]);
    }

    public function generate_quotation($leads_id)
    {       
        //echo '<pre>';print_r($_POST);die;
        $created = can_action('163', 'created');
        $edited = can_action('163', 'edited');
        if (!empty($created) || !empty($edited) && !empty($leads_id)) 
        {
            $this->form_validation->set_rules('first_name', lang('first_name'),'trim|required');
            $this->form_validation->set_rules('last_name', lang('last_name'),'trim|required');
            $this->form_validation->set_rules('mobile', lang('mobile'),'trim|required');
            $this->form_validation->set_rules('address', lang('address'),'trim|required');
            $this->form_validation->set_rules('state_id', lang('state'),'trim|required');
            $this->form_validation->set_rules('district_id', lang('district'),'trim|required');
            $this->form_validation->set_rules('city', lang('city'),'trim|required');
            $this->form_validation->set_rules('pincode', lang('pincode'),'trim|required');
            $this->form_validation->set_rules('lead_category_id', lang('lead_categories'),'trim|required');
            $this->form_validation->set_rules('product_id', lang('product'),'trim|required');
            $this->form_validation->set_rules('units', lang('units'),'trim|required');
            $this->form_validation->set_rules('approx_unit_rate', lang('approximate_unit_rate'),'trim|required'); 
            $this->form_validation->set_rules('unit_type', lang('unit_type'),'trim|required');  
            $this->form_validation->set_rules('system_type', lang('system_type'),'trim|required');
            $this->form_validation->set_rules('watt', lang('watt'),'trim|required');
            $this->form_validation->set_rules('consumer_number', lang('consumer_number'),'trim|required');
            
            if($this->form_validation->run() == true)
            {
                // get last quotation number
                $quo_no = $this->quotations_model->getLastQuotationNo($leads_id);
                
                if(empty($quo_no))
                {
                    $quno = sprintf("%03d",1);
                }
                else
                {
                    $quno = sprintf("%03d",(++$quo_no->quotation_number));
                }
                
                $data['lead_info'] = array(
                    'first_name' => $this->input->post('first_name'),
                    'middle_name' => $this->input->post('middle_name'),
                    'last_name' => $this->input->post('last_name'),
                    'address' => $this->input->post('address'),
                    'city' => $this->input->post('city'),
                    'pincode' => $this->input->post('pincode'),
                    'email' => $this->input->post('email'),
                    'mobile' => $this->input->post('mobile'),
                    'district_id' => $this->input->post('district_id'),
                    'lead_subcategory_id' => $this->input->post('lead_subcategory_id'),
                    'state_id' => $this->input->post('state_id'),
                    'lead_category_id' => $this->input->post('lead_category_id'),
                    'product_id' => $this->input->post('product_id'),
                    'consumer_number' => $this->input->post('consumer_number'),
                    'supplier' => $this->input->post('supplier'),
                    'approx_unit_rate' => $this->input->post('approx_unit_rate'),
                    'unit_type' => $this->input->post('unit_type'),
                    'units' => $this->input->post('units'),
                    'no_of_months' => $this->input->post('no_of_months'),
                    'mounting' => $this->input->post('mounting'),
                    'sanctioning_docc_netmetering' => $this->input->post('sanctioning_docc_netmetering'),
                    'fabrication_charge' => $this->input->post('fabrication_charge'),
                    'system_type' => $this->input->post('system_type'),
                    'watt' => $this->input->post('watt'),
                    'solar_panels' => $this->input->post('solar_panels'),
                    'inverter' => $this->input->post('inverter'),
                    'bi_directional_meter' => $this->input->post('bi_directional_meter'),
                    'solar_energy_meter' => $this->input->post('solar_energy_meter'),
                    'accessories_and_electrification' => $this->input->post('accessories_and_electrification'),
                    'installation_and_commissioning' => $this->input->post('installation_and_commissioning'),
                    'sanctioning_and_agreement_sys' => $this->input->post('sanctioning_and_agreement_sys'),
                    'made_a_doccumentation' => $this->input->post('made_a_doccumentation'),
                    'transportation' => $this->input->post('transportation'),
                    'battery_backup' => $this->input->post('battery_backup'),
                    'quno' => $quno,
                    'load_sanctioned' => $this->input->post('load_sanctioned'),
                    'rate_per_kw' => $this->input->post('rate_per_kw'),
                    'pay_terms_cond' => $this->input->post('pay_terms_cond')
                );

                $data['cal_config'] = $this->CalculationConfig_Model->getLatestCalConfiguration();

                if($this->input->post('requiredkw'))
                {
                    $requiredkW = $this->input->post('requiredkw');
                    $units = $this->input->post('units');
                    $unitconsumptionperyear = $units;
                    $unitconsumptionperday = $unitconsumptionperyear/365;
                    $unitconsumptionpermonth = $unitconsumptionperyear/12;
                    $data['required_kw'] = $requiredkW;
                }
                
                // get name of panel manufacturer
                if($this->input->post('gen_pdf') == 'pdf')
                {
                    $panelmanuf = $this->quotations_model->getManufName(explode(',', $this->input->post('panel_manuf')));
                }
                else
                {
                    $panelmanuf = $this->quotations_model->getManufName($this->input->post('panel_manuf'));
                }
                
                $panstr = '';
                if($panelmanuf)
                {
                    foreach($panelmanuf as $mf)
                    {
                        if($panstr=='')
                        {
                            $panstr = $mf->name;
                        }
                        else
                        {
                            $panstr = $panstr . '/' .$mf->name;
                        }
                    }
                }

                if($this->input->post('gen_pdf') == 'pdf')
                {
                    $invmanuf = $this->quotations_model->getManufName(explode(',', $this->input->post('inverter_manuf')));
                }
                else
                {
                    $invmanuf = $this->quotations_model->getManufName($this->input->post('inverter_manuf'));
                }
                // get names of inverter manufacturer
                $invmanuf = $this->quotations_model->getManufName($this->input->post('inverter_manuf'));
                $invstr = '';
                if($invmanuf)
                {
                    foreach($invmanuf as $mf)
                    {
                        if($invstr=='')
                        {
                            $invstr = $mf->name;
                        }
                        else
                        {
                            $invstr = $invstr . '/' .$mf->name;
                        }
                    }
                }
                    
                $data['panelmanuf'] = $panstr;
                $data['invmanuf'] = $invstr;

                if($this->input->post('gen_pdf') == 'view_pdf')
                {
                    $data['lead_info']['leads_id'] = $leads_id;
                    $data['lead_info']['panel_manuf'] = implode(',',$this->input->post('panel_manuf'));
                    $data['lead_info']['inverter_manuf'] = implode(',',$this->input->post('inverter_manuf'));
                    $lead_info = $this->items_model->check_by(array('leads_id' => $leads_id), 'tbl_leads');    
                    if (isset($_FILES['attachment']) && $_FILES['attachment']['name'] != '') 
                    {
                        if(is_file($lead_info->attachment))
                        {
                            unlink($lead_info->attachment);
                        }
                        $file_path = './uploads/lead_attachments/';
                        if (!is_dir($file_path)) 
                        {
                            mkdir($file_path, 0777, TRUE);
                        }
                        $date = date('Y-m-d H:i:s');
                        $name = strtotime($date);
                        $ext = pathinfo(basename( $_FILES['attachment']['name']), PATHINFO_EXTENSION);
                        $act_file_path = $file_path . $name.'.'.$ext;
                        move_uploaded_file($_FILES['attachment']['tmp_name'], $act_file_path);
                        $data['lead_info']['attachment'] = $act_file_path;
                    }
                    if($this->input->post('system_type') == 'Mono')
                    {
                        $unit_factor = 4.5;
                    }
                    else if($this->input->post('system_type') == 'Poly A Plus')
                    {
                        $unit_factor = 4.2;
                    }
                    else if($this->input->post('system_type') == 'Poly A')
                    {
                        $unit_factor = 3.7;
                    }
                    //calculate system generated unit
                    $sysgeneratedunitsperyear = number_format((float)($requiredkW * ($unit_factor*365)), 2, '.', '');
                    $sysgenunitpermonth = number_format((float)($sysgeneratedunitsperyear/12), 2, '.', '');
                    $sysgenunitperday = number_format((float)($sysgeneratedunitsperyear/365), 2, '.', '');
        
                    $data['sysgenerationinfo'] = array(
                        'sysgenunitperyear' => $sysgeneratedunitsperyear,
                        'sysgenunitperday' => $sysgenunitperday,
                        'sysgenunitpermonth' => $sysgenunitpermonth,
                    );

                    $data['consumption'] = array(
                        'unitconsumptionperday' => number_format((float)($unitconsumptionperday), 2, '.', ''),
                        'unitconsumptionpermonth' => number_format((float)($unitconsumptionpermonth), 2, '.', ''),
                        'unitconsumptionperyear' => number_format((float)($unitconsumptionperyear), 2, '.', ''),
                    );
                    $data['sel_pan_manuf'] = $this->input->post('panel_manuf');
                    $data['sel_inv_manuf'] = $this->input->post('inverter_manuf');
                    $data['panel_manuf'] = $this->items_model->getManufacturer('Panel');
                    $data['inverter_manuf'] = $this->items_model->getManufacturer('Inverter');
                    $data['gen_pdf'] = 'view_pdf';
                    $data['subview'] = $this->load->view('admin/quotations/pdf_view', $data, TRUE);
                    $this->load->view('admin/_layout_main', $data);
                }
                else if($this->input->post('gen_pdf') == 'pdf')
                {
                    // create pdf
                    $data['sysgenerationinfo'] = array(
                        'sysgenunitperyear' => $this->input->post('sysgenunitperyear'),
                        'sysgenunitperday' => $this->input->post('sysgenunitperday'),
                        'sysgenunitpermonth' => $this->input->post('sysgenunitpermonth'),
                    );

                    $data['consumption'] = array(
                        'unitconsumptionperday' => $this->input->post('unitconsumptionperday'),
                        'unitconsumptionpermonth' => $this->input->post('unitconsumptionpermonth'),
                        'unitconsumptionperyear' => $this->input->post('unitconsumptionperyear'),
                    );
                    $this->load->helper('dompdf');
                    $html = $this->load->view('admin/quotations/pdf_create', $data, TRUE);
                    //echo '<pre>';print_r($html);die;
                    $result = pdf_create($html, slug_it(lang('quotation') . '_' . $data['client_info']->client_number), 0, 'sassa', null);
                    
                    if($result)
                    {
                        $folder_path = './uploads/quotations';
                        if (!is_dir($folder_path)) 
                        {
                            mkdir($folder_path, 0777, TRUE);
                        }
                        $file_path = $folder_path.'/'.$leads_id.$quno.'.pdf';
                        if(file_put_contents($file_path, $result))
                        {
                            $quotation_path = $file_path;
                        }
                        
                        // add entry in quotation table
                        $quotation_data = array(
                            'lead_id' => $leads_id,
                            'quotation_number' => $quno,
                            'requiredkw' => $this->input->post('requiredkw'),
                            'mounting' => $this->input->post('mounting'),
                            'system_type' => $this->input->post('system_type'),
                            'sanctioning_docc_netmetering' => $this->input->post('sanctioning_docc_netmetering'),
                            'fabrication_charge' => $this->input->post('fabrication_charge'),
                            'solar_panels' => $this->input->post('solar_panels'),
                            'inverter' => $this->input->post('inverter'),
                            'bi_directional_meter' => $this->input->post('bi_directional_meter'),
                            'battery_backup' => $this->input->post('battery_backup'),
                            'solar_energy_meter' => $this->input->post('solar_energy_meter'),
                            'accessories_and_electrification' => $this->input->post('accessories_and_electrification'),
                            'installation_and_commissioning' => $this->input->post('installation_and_commissioning'),
                            'sanctioning_and_agreement_sys' => $this->input->post('sanctioning_and_agreement_sys'),
                            'made_a_doccumentation' => $this->input->post('made_a_doccumentation'),
                            'transportation' => $this->input->post('transportation'),
                            'rate' => $this->input->post('rate'),
                            'total_cost' => $this->input->post('total_cost'),
                            'cgst_rate' => $this->input->post('cgst_rate'),
                            'sgst_rate' => $this->input->post('sgst_rate'),
                            'igst_rate' => $this->input->post('igst_rate'),
                            'cgst_cost' => $this->input->post('cgst_cost'),
                            'sgst_cost' => $this->input->post('sgst_cost'),
                            'igst_cost' => $this->input->post('igst_cost'),
                            'project_cost' => $this->input->post('project_cost'),
                            'unitconsumptionperday' => $this->input->post('unitconsumptionperday'),
                            'unitconsumptionpermonth' => $this->input->post('unitconsumptionpermonth'),
                            'unitconsumptionperyear' => $this->input->post('unitconsumptionperyear'),
                            'sysgenunitperday' => $this->input->post('sysgenunitperday'),
                            'sysgenunitpermonth' => $this->input->post('sysgenunitpermonth'),
                            'sysgenunitperyear' => $this->input->post('sysgenunitperyear'),
                            'total_revenue_year' => $this->input->post('total_revenue_year'),
                            'paybakyears' => $this->input->post('paybakyears'),
                            'watt' => $this->input->post('watt'),
                            'noofpanels' => $this->input->post('noofpanels'),
                            'panel_manuf' => $this->input->post('panel_manuf'),
                            'inverter_manuf' => $this->input->post('inverter_manuf'),
                            'created_by' => $this->session->userdata('user_id'),
                            'created_date' => date('Y-m-d H:i:s'),
                            'quotation_path' => $quotation_path,
                            'load_sanctioned' => $this->input->post('load_sanctioned'),
                            'sub_payback_years' => $this->input->post('sub_payback_years'),
                            'sub_system_cost' => $this->input->post('sub_system_cost')
                        );
                        //echo '<pre>';print_r($quotation_data);die;
                        // insert into quotations table
                        $this->quotations_model->_table_name = 'tbl_quotations';
                        $this->quotations_model->_primary_key = 'quotations_id';
                        $return_id = $this->quotations_model->save($quotation_data);

                        // added entry in activity table
                        $activities = array(
                        'user' => $this->session->userdata('user_id'),
                        'module' => 'quotations',
                        'module_field_id' => $return_id,
                        'activity' => $action,
                        'icon' => 'fa-coffee'
                        );
                        
                        // Update into tbl_project
                        $this->quotations_model->_table_name = "tbl_activities"; //table name
                        $this->quotations_model->_primary_key = "activities_id";
                        $this->quotations_model->save($activities);

                        $type = 'success';
                        $message = lang('quotation_generated_success');
                        set_message($type, $message);
                        redirect('admin/quotations');
                    }
                }              
            }
            else
            {
                // fail in validation
                $data['error'] = (validation_errors() ? validation_errors() : '');
                $data['title'] = lang('all_leads');
                $data['active'] = 2;
                $data['leads_info'] = $this->items_model->check_by(array('leads_id' => $id), 'tbl_leads');
                $data['districts'] = $this->items_model->getAllDistrictsByStateId($this->input->post('state_id'));
                $data['subcategories'] = $this->items_model->getAllSubcategoriesByCatId($this->input->post('lead_category_id'));
                $data['panel_manuf'] = $this->items_model->getManufacturer('Panel');
                $data['inverter_manuf'] = $this->items_model->getManufacturer('Inverter');
                $data['states'] = $this->items_model->get_all_states();
                $data['categories'] = $this->items_model->get_all_lead_categories();
                $data['products'] = $this->items_model->get_all_products();
                $data['subview'] = $this->load->view('admin/quotations/quotation_list', $data, TRUE);
                $this->load->view('admin/_layout_main', $data);
            }
        }
    }

    public function quotationlist($id = NULL) 
    {
        $data['title'] = lang('all_leads');
        if (!empty($id)) 
        {
            $data['active'] = 3;

            $data['leads_info'] = $this->items_model->check_by(array('leads_id' => $id), 'tbl_leads');
            $data['quotation_list'] = $this->quotations_model->getQuotationsById($id);
        } 
        $data['subview'] = $this->load->view('admin/quotations/quotation_list', $data, TRUE);
        $this->load->view('admin/_layout_main', $data); //page load
    }

    // generate agreement
    public function generate_agreement($quotation_id)
    {       
        $created = can_action('163', 'created');
        $edited = can_action('163', 'edited');
        if (!empty($created) || !empty($edited) && !empty($quotation_id)) 
        {
            // get quotation information
            $quotation_details = $this->quotations_model->check_by(array('quotations_id' => $quotation_id),'tbl_quotations');      
            //echo '<pre>';print_r($quotation_details);die;
            if(!empty($quotation_details))
            {  
                $leads_details = $this->quotations_model->check_by(array('leads_id' => $quotation_details->lead_id),'tbl_leads');
                $quno = sprintf("%03d",($quotation_details->quotation_number));
                $data['lead_info'] = array(
                    'first_name' => $leads_details->first_name,
                    'middle_name' => $leads_details->middle_name,
                    'last_name' => $leads_details->last_name,
                    'address' => $leads_details->address,
                    'city' => $leads_details->city,
                    'pincode' => $leads_details->pincode,
                    'email' => $leads_details->email,
                    'mobile' => $leads_details->mobile,
                    'district_id' => $leads_details->district_id,
                    'lead_subcategory_id' => $leads_details->lead_subcategory_id,
                    'state_id' => $leads_details->state_id,
                    'lead_category_id' => $leads_details->lead_category_id,
                    'product_id' => $leads_details->product_id,
                    'consumer_number' => $leads_details->consumer_number,
                    'supplier' => $leads_details->supplier,
                    'approx_unit_rate' => $leads_details->approx_unit_rate,
                    'unit_type' => $leads_details->unit_type,
                    'units' => $leads_details->units,
                    'no_of_months' => $leads_details->no_of_months,
                    'leads_id' => $leads_details->leads_id,

                    'quotation_id' => $quotation_details->quotations_id,
                    'panel_manuf' => $quotation_details->panel_manuf,
                    'inverter_manuf' => $quotation_details->inverter_manuf,
                    'rate_per_kw' => $quotation_details->rate,

                    'mounting' => $quotation_details->mounting,
                    'sanctioning_docc_netmetering' => $quotation_details->sanctioning_docc_netmetering,
                    'fabrication_charge' => $quotation_details->fabrication_charge,
                    'system_type' => $quotation_details->system_type,
                    'watt' => $quotation_details->watt,
                    'solar_panels' => $quotation_details->solar_panels,
                    'inverter' => $quotation_details->inverter,
                    'bi_directional_meter' => $quotation_details->bi_directional_meter,
                    'solar_energy_meter' => $quotation_details->solar_energy_meter,
                    'accessories_and_electrification' => $quotation_details->accessories_and_electrification,
                    'installation_and_commissioning' => $quotation_details->installation_and_commissioning,
                    'sanctioning_and_agreement_sys' => $quotation_details->sanctioning_and_agreement_sys,
                    'made_a_doccumentation' => $quotation_details->made_a_doccumentation,
                    'transportation' => $quotation_details->transportation,
                    'battery_backup' => $quotation_details->battery_backup,
                    'quno' => $quno,
                    'load_sanctioned' => $quotation_details->load_sanctioned,
                    'pay_terms_cond' => $quotation_details->pay_terms_cond,
                    'cgst_rate' => $quotation_details->cgst_rate,
                    'sgst_rate' => $quotation_details->sgst_rate,
                    'igst_rate' => $quotation_details->igst_rate,
                    'cgst_cost' => $quotation_details->cgst_cost,
                    'sgst_cost' => $quotation_details->sgst_cost,
                    'igst_cost' => $quotation_details->igst_cost
                );
                //echo '<pre>';print_r($data['lead_info']);die;
                $data['required_kw'] = $quotation_details->requiredkw;
                //panel maufacturer
                $panelmanuf = $this->quotations_model->getManufName(explode(',', $quotation_details->panel_manuf));
                $panstr = '';
                if($panelmanuf)
                {
                    foreach($panelmanuf as $mf)
                    {
                        if($panstr=='')
                        {
                            $panstr = $mf->name;
                        }
                        else
                        {
                            $panstr = $panstr . '/' .$mf->name;
                        }
                    }
                }

                $invmanuf = $this->quotations_model->getManufName(explode(',', $quotation_details->inverter_manuf ));

                $invstr = '';
                if($invmanuf)
                {
                    foreach($invmanuf as $mf)
                    {
                        if($invstr=='')
                        {
                            $invstr = $mf->name;
                        }
                        else
                        {
                            $invstr = $invstr . '/' .$mf->name;
                        }
                    }
                }
                    
                $data['panelmanuf'] = $panstr;
                $data['invmanuf'] = $invstr;

                $data['sysgenerationinfo'] = array(
                    'sysgenunitperyear' => $quotation_details->sysgenunitperyear,
                    'sysgenunitperday' => $quotation_details->sysgenunitperday,
                    'sysgenunitpermonth' => $quotation_details->sysgenunitpermonth,
                );

                $data['consumption'] = array(
                    'unitconsumptionperday' => $quotation_details->unitconsumptionperday,
                    'unitconsumptionpermonth' => $quotation_details->unitconsumptionpermonth,
                    'unitconsumptionperyear' => $quotation_details->unitconsumptionperyear,
                );                
                $data['docc_type'] = 'agreement';
                if($this->input->post('gen_pdf')=='pdf')
                {
                    // create pdf
                    $this->load->helper('dompdf');
                    $html = $this->load->view('admin/quotations/pdf_create', $data, TRUE);
                    //echo '<pre>';print_r($html);die;
                    $result = pdf_create($html, null, 0, 'sassa', null);
                    
                    if($result)
                    {
                        $folder_path = './uploads/agreements';
                        if (!is_dir($folder_path)) 
                        {
                            mkdir($folder_path, 0777, TRUE);
                        }
                        $file_path = $folder_path.'/'.$quotation_details->lead_id.$quno.'.pdf';
                        if(file_put_contents($file_path, $result))
                        {
                            $agreement_path = $file_path;
                        }

                    // store agreement path into lead table
                        $lead_data = array(
                            'lead_status' => 'Agreement Generated',
                            'agreement_path' => $agreement_path,
                            'updated_by' => $this->session->userdata('user_id'),
                            'updated_date' => date('Y-m-d H:i:s')
                        );
                        $this->quotations_model->_table_name = "tbl_leads"; //table name
                        $this->quotations_model->_primary_key = "leads_id";
                        $this->quotations_model->save($lead_data,$quotation_details->lead_id);

                        // added entry in activity table
                        $action = 'Agreement Generated';
                        $activities = array(
                        'user' => $this->session->userdata('user_id'),
                        'module' => 'quotations',
                        'module_field_id' => $return_id,
                        'activity' => $action,
                        'icon' => 'fa-coffee'
                        );
                        
                        // Update into tbl_project
                        $this->quotations_model->_table_name = "tbl_activities"; //table name
                        $this->quotations_model->_primary_key = "activities_id";
                        $this->quotations_model->save($activities);

                        $type = 'success';
                        $message = lang('agreement_generated_success');
                        set_message($type, $message);
                        redirect('admin/quotations');
                    }
                }
                else
                {
                    $data['gen_pdf'] = 'view_pdf';
                    $data['subview'] = $this->load->view('admin/quotations/pdf_view', $data, TRUE);
                    $this->load->view('admin/_layout_main', $data);
                }               

            }                             
            
        }
    }
}
