<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Commonapi extends MY_Controller
{

    public function __construct()
    {
        parent::__construct();  
        $this->load->model('rest_api_models/State_Model');     
        $this->load->model('rest_api_models/District_Model');  
        $this->load->model('rest_api_models/KWSolarRateCard_Model'); 
        $this->load->model('rest_api_models/Common_Model');     
        $this->load->model('Lead_Categories_Model');
        $this->load->model('Lead_Subcategories_Model');
        $this->load->model('login_model');
        $this->load->model('Items_Model');
        $this->load->model('FAQ_Model');
        $this->load->model('user_model');
    }                       

    function getAllStates()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $states = $this->State_Model->get_states();
            if($states)
            {
                $response=array('success' => true, 'data'=>$states);
                echo json_encode($response);
            }
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }

    function getAllDistricts()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $districts = $this->District_Model->get_districts();
            if($districts)
            {
                $response=array('success' => true, 'data'=>$districts);
                echo json_encode($response);
            }
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    } 

    function getAllCustomerCategories()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $categories = $this->Lead_Categories_Model->get_customer_categories();
            if($categories)
            {
                $response=array('success' => true, 'data'=>$categories);
                echo json_encode($response);
            }
            else
            {
                $response=array('success' => false, 'message'=>'No data available in table.');
                echo json_encode($response);
            }
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }

    function getAllCustomerSubcategories()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $subcategories = $this->Lead_Subcategories_Model->get_customer_subcategories();
            if($subcategories)
            {
                $response=array('success' => true, 'data'=>$subcategories);
                echo json_encode($response);
            }
            else
            {
                $response=array('success' => false, 'message'=>'No data available in table.');
                echo json_encode($response);
            }
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }

    function getAllProducts()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $products = $this->Items_Model->get_product_list();
            if($products)
            {
                $response=array('success' => true, 'data'=>$products);
                echo json_encode($response);
            }
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }

    function getAllFAQ()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $faq = $this->FAQ_Model->get_all_faqs();
            if($faq)
            {
                $response=array('success' => true, 'data'=>$faq);
                echo json_encode($response);
            }
            else
            {
                $response = array('success' => false, 'message' => ("No data available in table."));
                echo json_encode($response);
            }
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }

    function getAllKWSolarRateCard()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $ratecard = $this->KWSolarRateCard_Model->get_all_KWSolarRateCard();
            if($ratecard)
            {
                $response=array('success' => true, 'data'=>$ratecard);
                echo json_encode($response);
            }
            else
            {
                $response = array('success' => false, 'message' => ("No data available in table."));
                echo json_encode($response);
            }
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }

    public function login_process()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $this->form_validation->set_rules('email', 'Email','trim|required');
            $this->form_validation->set_rules('password', 'Password','trim|required');
            if ($this->form_validation->run() == true)
            {
                $email = $this->input->post('email');
                $password = $this->input->post('password');
                $result = $this->Common_Model->getUserDetails($email, $password);
                if($result)
                {
                    $notification_id = $this->input->post('oneSignal_id');
                    if(!empty($notification_id))
                    {
                        // add notification id
                        $userno_id = array(
                            'notification_id' => $notification_id
                        );
                        $this->user_model->_table_name = 'tbl_users';
                        $this->user_model->_primary_key = "user_id";
                        $this->user_model->save($userno_id,$result->user_id);
                    }
                    $response = array('success' => true, 'data' => $result, 'message' => ("Login Successfully"));
                }
                else
                {
                    $response = array('success' => false, 'message' => ("Invalid Login Details"));
                }
            }
            else
            {
                $response = array('success' => false, 'message' => (validation_errors()));
            }
            echo json_encode($response);
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }

    // get menus according to role id
    public function home_menu()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $this->form_validation->set_rules('user_id', 'User Id','trim|required');
            if ($this->form_validation->run() == true)
            {
                $user_id = $this->input->post('user_id');
                // get userdetail
                $designation_info = $this->Common_Model->get_user_designation_id($user_id);               

                if($designation_info->designations == 'Sales Manager')
                {
                    $data['page_title'] =  ("Home");
                    // get menu name by designation id
                    $menus = $this->Common_Model->get_menu_by_designation($designation_info->designations_id);

                    $response = array( 'success' => true, 'user_type' => $designation_info->designations , 'page_title' => "Home", 'menu' => $menus, 'message'  => ''  );
                }
                else
                {
                    $response = array( 'success' => false, 'user_type' => $designation_info->designations , 'message'  => 'You dont have permission to do this.'  );
                }
            }
            else
            {
                $response = array('success' => false, 'message' => (validation_errors()));
            }
            echo json_encode($response);
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }

    //update login status
    public function updateLoginStatus()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $this->form_validation->set_rules('salesman_id', 'Salesman','trim|required');
            if ($this->form_validation->run() == true)
            {
                $salesman_id = $this->input->post('salesman_id');
                //0 for not logged in
                //1 for lgged in
                $statusData = array(
                    'activated' => 0,
                );

                if($this->Common_Model->updateLoginStatusData($statusData, $salesman_id))
                {
                    $response = array('success' => true,'message' => ("Log Out Successfully"));
                }
                else
                {
                    $response = array('success' => false,'message' => ("Something went Wrong"));
                }
            }
            else
            {
                $response = array('success' => false, 'message' => (validation_errors()));
            }
            echo json_encode($response);
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }

    // Forgot password
    public function forgot_pasword()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $this->form_validation->set_rules('email', 'Email','trim|required');
            if ($this->form_validation->run() == true)
            {
                $email = $this->input->post('email');
                $login_details = $this->login_model->get_user_details($email);
                if($login_details)
                {
                    $data = array(
                        'user_id' => $login_details->user_id,
                        'username' => $login_details->username,
                        'email' => $login_details->email,
                        'new_pass_key' => md5(rand() . microtime()),
                    );
                    $this->login_model->set_password_key($login_details->user_id, $data['new_pass_key']);

                    $this->send_email_forgot_password($data['email'], $data);
                    $response = array('success' => true, 'message' => ("Email sent Successfully"));
                }                       
            }
            else
            {
                $response = array('success' => false, 'message' => (validation_errors()));
            }
            echo json_encode($response);
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }

    }

    function send_email_forgot_password($email, $data)
    {
        $email_template = email_templates(array('email_group' => 'forgot_password'), $data['user_id'], true);

        $message = $email_template->template_body;
        $subject = $email_template->subject;

        $site_url = str_replace("{SITE_URL}", base_url() . 'login', $message);
        $key_url = str_replace("{PASS_KEY_URL}", base_url() . 'login/reset_password/' . $data['user_id'] . '/' . $data['new_pass_key'], $site_url);
        $message = str_replace("{SITE_NAME}", config_item('company_name'), $key_url);

        $params['recipient'] = $email;

        $params['subject'] = '[ ' . config_item('company_name') . ' ] ' . $subject;
        $params['message'] = $message;

        $params['resourceed_file'] = '';

        $this->login_model->send_email($params);
    }

    public function getProfile()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $this->form_validation->set_rules('user_id', 'User Id','trim|required');
            if ($this->form_validation->run() == true) 
            {
                $user_id = $this->input->post('user_id');
                $profile_data = $this->Common_Model->get_profile_details($user_id);
                if($profile_data) 
                {
                    $rolename = $profile_data->role_id ==1 ? 'Admin' : ($profile_data->role_id==2 ? 'Customer' : 'Staff');
                    $profile_arr['id']                  = array("key" => ("Id"), "value" => $profile_data->user_id, "field_name" => "id");
                    $profile_arr['employment_id']                  = array("key" => ("Employment Id"), "value" => $profile_data->employment_id, "field_name" => "employment_id");
                    $profile_arr['role_id']                  = array("key" => ("Role Id"), "value" => $profile_data->role_id, "field_name" => "role_id");
                    $profile_arr['name']                  = array("key" => ("Name"), "value" => $profile_data->fullname, "field_name" => "name");
                    $profile_arr['department']                  = array("key" => ("Department"), "value" => $profile_data->deptname, "field_name" => "department");
                    $profile_arr['phone']                  = array("key" => ("Phone"), "value" => $profile_data->phone, "field_name" => "phone");
                    $profile_arr['mobile']                  = array("key" => ("Mobile"), "value" => $profile_data->mobile, "field_name" => "mobile");
                    $profile_arr['address']                  = array("key" => ("Address"), "value" => $profile_data->address, "field_name" => "address");
                    $profile_arr['email']                  = array("key" => ("Email"), "value" => $profile_data->email, "field_name" => "email");
                    $profile_arr['role_name']                  = array("key" => ("Role Name"), "value" => $rolename, "field_name" => "role_name");
                    $profile_arr['designations']                  = array("key" => ("Designation"), "value" => $profile_data->designations, "field_name" => "designations");

                    $data['profile'] = $profile_arr;
                    $extra_arr['profile_edit_title'] = ("Edit Profile");
                    $extra_arr['send_data_btn'] = ("Submit");
                    $extra_arr['cancel_data_btn'] = ("Cancel");
                    $data['extra_text']                 = $extra_arr;
                    $response = array('success' => true, 'data' => $data, 'message' => (""));
                }
                else
                {
                    $response = array('success' => false, 'data' => '', 'message' => ("No data Found"));
                }          
                echo json_encode($response);     
            }
            else
            {
                $response = array('success' => false, 'message' => (validation_errors()));
                echo json_encode($response);
            }
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }

    public function resetPassword()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $this->form_validation->set_rules('user_id', 'User Id','trim|required');
            if ($this->form_validation->run() == true) 
            {
                $user_id = $this->input->post('user_id');
                $old_pass       = ($this->input->post('old_pass'))              ? trim($this->input->post('old_pass')) : '';
                $new_pass       = ($this->input->post('new_pass'))              ? trim($this->input->post('new_pass')) : '';
                $new_pass_con   = ($this->input->post('new_pass_con'))          ? trim($this->input->post('new_pass_con')) : '';

                if( $old_pass == "" )
                {
                    $response = array( 'success' => false, 'data' => '' , 'message' => ("Please enter current password") );
                    echo json_encode($response);
                }
                if( $new_pass == "" )
                {
                    $response = array( 'success' => false, 'data' => '' , 'message' => ("Please enter new password") );
                    echo json_encode($response);
                }
                
                if( $new_pass != $new_pass_con )
                {
                    $response = array( 'success' => false, 'data' => '' , 'message' => ("Password confirm password mismatched"));
                    echo json_encode($response);
                }
                else
                {
                    $post_params = array(
                        'password' => $this->Common_Model->hash($new_pass),
                    );
                    $getOldPsw = $this->Common_Model->validate_user_password($user_id, $this->Common_Model->hash($old_pass));
                    if($getOldPsw)
                    {
                        // Update password
                        $if_updated = $this->Common_Model->updateProfile($post_params, $user_id);
                        if($if_updated)
                        {
                            $profile_data = $this->Common_Model->get_profile_details($user_id);
                            $activities = array(
                                'user' => $user_id,
                                'module' => 'user',
                                'module_field_id' => $user_id,
                                'activity' => 'activity_reset_password',
                                'icon' => 'fa-user',
                                'value1' => $profile_data->fullname,
                            );

                            $this->user_model->_table_name = 'tbl_activities';
                            $this->user_model->_primary_key = "activities_id";
                            $this->user_model->save($activities);

                            $response = array( 'success' => true, 'data' => $profile_data , 'message' => ("Password successfully chnaged"));
                            echo json_encode($response);
                        }
                        else
                        {
                            $response = array( 'success' => false, 'data' => '' , 'message' => ("Something went wrong during update password,please try after sometime."));
                            echo json_encode($response);
                        }
                    }
                    else
                    {
                        $response = array( 'success' => false, 'data' => '' , 'message' => lang('password_does_not_match'));
                        echo json_encode($response);
                    }
                } 
            }
            else
            {
                $response = array('success' => false, 'message' => (validation_errors()));
                echo json_encode($response);
            }
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }        
    }

    // check mobile number is present in lead table
    public function checkduplicatemobile()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $this->form_validation->set_rules('mobile', 'Mobile','trim|required');
            if ($this->form_validation->run() == true) 
            {
                $mobile = $this->input->post('mobile');
                $result = $this->Common_Model->check_mobile_duplicate($mobile);
                if($result)
                {
                    $response = array( 'success' => false, 'data' => '' , 'message' => ('Mobile number present in the system.'));
                        echo json_encode($response);
                }
                else
                {
                    $response = array( 'success' => true, 'data' => '' , 'message' => ('Mobile number not present in the system.'));
                        echo json_encode($response);
                }
            }
            else
            {
                $response = array('success' => false, 'message' => (validation_errors()));
                echo json_encode($response);   
            }
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }
    
	public function getallmanufacturers()
	{
		$type = $this->input->post('type') ? $this->input->post('type') : 'Electricity';
		$receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
		if ($receivedTokan == $this->token) {
			$manufacturers = $this->Items_Model->get_manufacturer_list($type);
			if ($manufacturers) {
				$response = array('success' => true, 'data'=>$manufacturers);
				echo json_encode($response);
			}
		} else {
			$response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
			echo json_encode($response);
		}
	}

    public function getAnnouncementById()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if ($receivedTokan == $this->token) 
        {
            $this->form_validation->set_rules('announcements_id', 'Announcements Id','trim|required');
            if ($this->form_validation->run() == true) 
            {
                $announcements_id = $this->input->post('announcements_id');
                $result = $this->Common_Model->check_by(array('announcements_id' => $announcements_id), 'tbl_announcements');
                if($result)
                {
                    $response = array( 'success' => true, 'data' => $result);
                    echo json_encode($response);
                }
                else
                {
                    $response = array( 'success' => false, 'message' => 'No record found.');
                    echo json_encode($response);
                }
            }
            else
            {
                $response = array('success' => false, 'message' => (validation_errors()));
                echo json_encode($response);
            }
        } else {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }

    public function getAllExpenseCategory()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if ($receivedTokan == $this->token) 
        {
            $result = $this->Common_Model->getAllRecords('tbl_expense_category');
            if($result)
            {
                $response = array( 'success' => true, 'data' => $result);
                echo json_encode($response);
            }
            else
            {
                $response = array( 'success' => false, 'message' => 'No record found.');
                echo json_encode($response);
            }            
        } 
        else 
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }

    public function getAllPaymentMethods()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if ($receivedTokan == $this->token) 
        {
            $result = $this->Common_Model->getAllRecords('tbl_payment_methods');
            if($result)
            {
                $response = array( 'success' => true, 'data' => $result);
                echo json_encode($response);
            }
            else
            {
                $response = array( 'success' => false, 'message' => 'No record found.');
                echo json_encode($response);
            }            
        } 
        else 
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }

    public function customer_login()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $this->form_validation->set_rules('username', 'Username','trim|required');
            $this->form_validation->set_rules('password', 'Password','trim|required');
            if ($this->form_validation->run() == true)
            {
                $username = $this->input->post('username');
                $password = $this->input->post('password');
                $result = $this->Common_Model->getCustomerDetails($username, $password);
                if($result)
                {
                    $notification_id = $this->input->post('oneSignal_id');
                    if(!empty($notification_id))
                    {
                        // add notification id
                        $userno_id = array(
                            'notification_id' => $notification_id
                        );
                        $this->user_model->_table_name = 'tbl_client';
                        $this->user_model->_primary_key = "client_id";
                        $this->user_model->save($userno_id,$result->user_id);
                    }
                    $response = array('success' => true, 'data' => $result, 'message' => ("Login Successfully"));
                }
                else
                {
                    $response = array('success' => false, 'message' => ("Invalid Login Details"));
                }
            }
            else
            {
                $response = array('success' => false, 'message' => (validation_errors()));
            }
            echo json_encode($response);
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }
}









