<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Leadapi extends MY_Controller
{
    public function __construct()
    {
        parent::__construct();
        $this->load->library('form_validation');
        $this->load->model('rest_api_models/State_Model');
        $this->load->model('rest_api_models/District_Model');
        $this->load->model('rest_api_models/CalculationConfig_Model');
        $this->load->model('rest_api_models/Common_Model');
        $this->load->model('Items_Model');       
    }

    function addLead()
    {       
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $this->form_validation->set_rules('first_name', 'First Name','trim|required');
            $this->form_validation->set_rules('last_name', 'Last Name','trim|required');
            $this->form_validation->set_rules('phone', 'Phone Number','trim|required|regex_match[/^[0-9]{10}$/]');
            
            $this->form_validation->set_rules('flag', 'Flag','trim|required');
            
            if ($this->form_validation->run() == true) 
            {
                // check duplicate mobile
                $where = array('mobile' => $this->input->post('phone'), 'first_name' => $this->input->post('first_name'), 'last_name' => $this->input->post('last_name'));
                $result = $this->Common_Model->check_duplicate_lead($where);
                if(!$result)
                {
                    $flag = $this->input->post('flag');
                    $otp = $this->input->post('otp') ? $this->input->post('otp') : '';
                    // send otp if otp is empty.
                    if(empty($otp) && $flag)
                    {
                        // generate otp
                        $new_otp = $this->generateOTP();
                        $mobileNum = $this->input->post('phone');
                        $message = '%3C%23%3E Hello '.$this->input->post('first_name').', Welcome to AFM Solar System Pvt. Ltd. Your OTP is ' . $new_otp . ' pfH7juRe9tO';  
                        $otpResponse = $this->sendsmsGET($mobileNum, $message);
                        //$new_otp = '123456';
                        $otpResponse=true;
                        if($otpResponse)
                        {
                            $response = array('success' => true, 'mobile_number' => $mobileNum, 'otp' => $new_otp, 'message' => ("OTP Sent Successfully"));
                            echo json_encode($response);
                        }
                        else
                        {
                            $response = array('success' => false, 'message' => ("Something went wrong while sending OTP"));
                            echo json_encode($response);
                        }
                    }
                    else
                    {
                        $designation = $this->input->post('designation');

                        $data = array(
                            'first_name' => $this->input->post('first_name'),
                            'middle_name' => $this->input->post('middle_name'),
                            'last_name' => $this->input->post('last_name'),
                            'email' => $this->input->post('email'),
                            'mobile' => $this->input->post('phone'),
                            'address' => $this->input->post('address'),
                            'pincode' => $this->input->post('pin_code'),
                            'city' => $this->input->post('city'),
                            'state_id' => $this->input->post('state_id'),
                            'district_id' => $this->input->post('district_id'),
                            'lead_category_id'=>$this->input->post('cust_category_id'),
                            'lead_subcategory_id'=>$this->input->post('cust_subcategory_id'),
                            'product_id'=>$this->input->post('product_id'),
                            'consumer_number'=> $this->input->post('consumer_number'),
                            'supplier'=> $this->input->post('supplier'),
                            'units'=> $this->input->post('units'),
                            'unit_type'=> $this->input->post('unit_type'),
                            'no_of_months'=> $this->input->post('no_of_months'),
                            'approx_unit_rate'=> $this->input->post('approx_unit_rate'),
                            'created_by'=> $this->input->post('created_by'),
                            'calculation_type'=> $this->input->post( 'calculation_type' ),
                            'created_time' => date( 'Y-m-d H:i:s'),
                            'lead_status'  => 'New',
                            'type' => 'Lead',
                            'notification_id' => $this->input->post('oneSignal_id')
                        );
                           
                        if($designation == 'Sales Manager')
                        {
                            $data['referred_by'] = $this->input->post('created_by');
                            $data['lead_type'] = 'Hot';
                            $data['reference'] = $this->input->post('reference');
                            $lead_source_id = $this->db->get_where('tbl_lead_source',array('lead_source' => 'Own'))->row()->lead_source_id;
                            if(!empty($lead_source_id))
                            {
                               $data['lead_source_id'] = $lead_source_id; 
                            }
                            $data['assigned_to'] = $this->input->post('created_by');
                            $data['lead_status'] = 'Assigned';
                        }

                        if($this->input->post('calculation_type') == 'fileupload')
                        {
                            $is_file_attached = $this->input->post('is_file_attached');
                            $act_file_path = "";
                            if($is_file_attached == '1')
                            {
                                $file_path = "uploads/lead_attachments/";
                                if (!is_dir($file_path)) 
                                {
                                    mkdir($file_path, 0777, TRUE);
                                }
                                $date = date('Y-m-d H:i:s');
                                $name = strtotime($date);

                                $ext = pathinfo(basename( $_FILES['file']['name']), PATHINFO_EXTENSION);
                                $act_file_path = $file_path . $name.'.'.$ext;
                                move_uploaded_file($_FILES['file']['tmp_name'], $act_file_path);
                            }
                            $data['attachment'] = $act_file_path;
                        }

                        $this->Items_Model->_table_name = 'tbl_leads';
                        $this->Items_Model->_primary_key = 'leads_id';
                        $lead_id = $this->Items_Model->save($data);
                    
                        if($lead_id)
                        {                 
                            // generate lead id
                            $year= date("Y");
                            $statePadded = sprintf("%02d", $this->input->post('state_id'));
                            $districtPadded = sprintf("%04d",$this->input->post('district_id'));
                            $idPadded = sprintf("%06d", $lead_id);
                            $code=$year.$statePadded.$districtPadded.$idPadded;
                            $lead_array = array('lead_number' => $code );
                            // update lead table 
                            $u_data['lead_number'] = $code;
                            $rows = $this->Items_Model->save($u_data, $lead_id);

                            $created_by = $this->input->post('created_by');
                            $action = 'activity_save_leads';
                            // added entry in activity table
                            $activity = array(
                                'user' => $created_by,
                                'module' => 'leads',
                                'module_field_id' => $lead_id,
                                'activity' => $action,
                                'icon' => 'fa-rocket',
                                'link' => 'admin/leads/leads_details/' . $lead_id,
                                'value1' => $data['first_name'] . ' ' . $data['middle_name'] . ' ' . $data['last_name']
                            );
                            $this->Items_Model->_table_name = 'tbl_activities';
                            $this->Items_Model->_primary_key = 'activities_id';
                            $this->Items_Model->save($activity);
                        
                            if($rows)
                            {
                                // send email
                                $leads_info = $this->Items_Model->check_by(array('leads_id' => $lead_id), 'tbl_leads');
                                $config_detail = $this->CalculationConfig_Model->getLatestCalConfiguration();
                                if($config_detail)
                                {
                                    $leads_info->configuration = $config_detail;
                                }
                                else
                                {
                                    $leads_info->configuration = '';
                                }
                           
                                // Send email to support team
                                // get email from table
                            
                                $to = 'support@afmsolarsystem.com';
                                $state = $this->State_Model->get_state_by_id($this->input->post('state_id'));
                                $district = $this->District_Model->get_district_by_id($this->input->post('district_id'));
                                $email_data = array(
                                    'first_name' => $leads_info->first_name,
                                    'middle_name' => $leads_info->middle_name,
                                    'last_name' => $leads_info->last_name,
                                    'mobile' => $leads_info->mobile,
                                    'email' => $leads_info->email,
                                    'address' => $leads_info->address,
                                    'city' => $leads_info->city,
                                    'state' => $state,
                                    'district' => $district,
                                    'attachment' => $leads_info->attachment,
                                    'user_id' => $this->input->post('created_by'),
                                );
                       
                                $this->send_email('new_leads',$email_data,$to);
                            
                                $response = array('success' => true, 'message'=>'Lead details added successfully', 'data' => $leads_info);
                                echo json_encode($response);
                            }
                            else
                            {
                                $response = array('success' => false, 'message' => 'Something went wrong during inserting lead number.');
                                echo json_encode($response);
                            }
                        }
                        else
                        {
                            $response = array('success' => false, 'message' => 'Something went wrong during inserting record,please try after sometime');
                            echo json_encode($response);
                        }
                    }
                }
                else
                {
                    $response = array( 'success' => false, 'data' => '' , 'message' => ('Mobile number and lead data present in the system.'));
                    echo json_encode($response);
                }                
            }
            else
            {
                $response = array('success' => false, 'message' => (validation_errors()));
                echo json_encode($response);
            }
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }

    function send_email($type, $data, $email)
    {
        $email_template = email_templates(array('email_group' => 'new_leads'), $data['user_id'], true);

        $message = $email_template->template_body;
        $subject = $email_template->subject;

        $first_name = str_replace("{FIRST_NAME}", $data['first_name'], $message);
        $middle_name = str_replace("{MIDDLE_NAME}", $data['middle_name'], $first_name);
        $last_name = str_replace("{LAST_NAME}", $data['last_name'], $middle_name);
        $mobile_no = str_replace("{MOBILE_NO}", $data['mobile'], $last_name);
        $email = str_replace("{EMAIL}", $data['email'], $mobile_no);
        $address = str_replace("{ADDRESS}", $data['address'], $email);
        $city = str_replace("{CITY}", $data['city'], $address);
        $state = str_replace("{STATE}", $data['state'], $city);
        $district = str_replace("{DISTRICT}", $data['district'], $state);

        $params['recipient'] = $email;

        $params['subject'] = $subject;
        $params['message'] = $message;

        $params['resourceed_file'] = '';

        $this->Items_Model->send_email($params);
    }

    // this function is get assigned leads
    public function getAssignedLeads()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $this->form_validation->set_rules('user_id', 'User Id','trim|required');
            if ($this->form_validation->run() == true) 
            {
                $user_id = $this->input->post('user_id');
                $leads_info = $this->Items_Model->get_result(array('assigned_to' => $user_id), 'tbl_leads');
                if($leads_info)
                {
                    $response=array('success' => true, 'data' => $leads_info);
                    echo json_encode($response);
                }
                else
                {
                    $response=array('success' => false, 'message'=>'No data available in table.');
                    echo json_encode($response);
                }
            }
            else
            {
                $response = array('success' => false, 'message' => (validation_errors()));
                echo json_encode($response);
            }
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }    


    function updateLead()
    {       
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $this->form_validation->set_rules('leads_id', 'Lead Id','trim|required');
            $this->form_validation->set_rules('first_name', 'First Name','trim|required');
            $this->form_validation->set_rules('last_name', 'Last Name','trim|required');
            $this->form_validation->set_rules('phone', 'Phone Number','trim|required|regex_match[/^[0-9]{10}$/]');
            $this->form_validation->set_rules('state_id', 'State','trim|required'); 
            $this->form_validation->set_rules('district_id', 'District','trim|required');
            $this->form_validation->set_rules('cust_category_id', 'Lead Category Id','trim|required');
            $this->form_validation->set_rules('product_id', 'Product','trim|required');
            $this->form_validation->set_rules('city', 'City','trim|required');
            $this->form_validation->set_rules('calculation_type', 'Calculation Type','trim|required');
            $this->form_validation->set_rules('consumer_number', 'Consumer Number','trim|required');
            $this->form_validation->set_rules('units', 'Units','trim|required');
            $this->form_validation->set_rules('unit_type', 'Unit Type','trim|required');
            $this->form_validation->set_rules('approx_unit_rate', 'Approx Unit Rate','trim|required');            

            if($this->input->post('unit_type') == 'Monthly')
            {
                $this->form_validation->set_rules('no_of_months', 'No Of Months','trim|required');
            }
            if ($this->form_validation->run() == true) 
            {
                $leads_id = $this->input->post('leads_id');
                // get lead info by leads id
                $leads_info = $this->Items_Model->check_by(array('leads_id' => $lead_id), 'tbl_leads');

                // check duplicate mobile
                $result = $this->Common_Model->check_mobile_duplicate($this->input->post('phone'), $leads_id);
                
                if(!$result)
                {
                    $data = array(
                        'first_name' => $this->input->post('first_name'),
                        'middle_name' => $this->input->post('middle_name'),
                        'last_name' => $this->input->post('last_name'),
                        'email' => $this->input->post('email'),
                        'mobile' => $this->input->post('phone'),
                        'address' => $this->input->post('address'),
                        'pincode' => $this->input->post('pin_code'),
                        'city' => $this->input->post('city'),
                        'state_id' => $this->input->post('state_id'),
                        'district_id' => $this->input->post('district_id'),
                        'lead_category_id'=>$this->input->post('cust_category_id'),
                        'lead_subcategory_id'=>$this->input->post('cust_subcategory_id'),
                        'product_id'=>$this->input->post('product_id'),
                        'consumer_number'=> $this->input->post('consumer_number'),
                        'supplier'=> $this->input->post('supplier'),
                        'units'=> $this->input->post('units'),
                        'unit_type'=> $this->input->post('unit_type'),
                        'no_of_months'=> $this->input->post('no_of_months'),
                        'approx_unit_rate'=> $this->input->post('approx_unit_rate'),
                        'calculation_type'=> $this->input->post( 'calculation_type' ),
                        'updated_date' => date( 'Y-m-d H:i:s'),
                        'updated_by' => $this->input->post('user_id'),
                        'salesmanager_comment'=> $this->input->post('salesmanager_comment'),
                    );
                    if($this->input->post('generate_quotation') == '1')
                    {
                        $lead_status = 'Request For Quotation';
                    }
                    if(!empty($lead_status))
                    {
                        $data['lead_status'] = $lead_status;
                    }

                    $is_file_attached = $this->input->post('is_file_attached');
                    $act_file_path = "";
                    if($is_file_attached == '1')
                    {
                        $file_path = "uploads/lead_attachments/";
                        if (!is_dir($file_path)) 
                        {
                            mkdir($file_path, 0777, TRUE);
                        }
                        $date = date('Y-m-d H:i:s');
                        $name = strtotime($date);

                        $ext = pathinfo(basename( $_FILES['file']['name']), PATHINFO_EXTENSION);
                        $act_file_path = $file_path . $name.'.'.$ext;
                        move_uploaded_file($_FILES['file']['tmp_name'], $act_file_path);
                        // delete old file if present
                        if($leads_info->attachment)
                        {
                            unlink($leads_info->attachment);
                        }
                        $data['attachment'] = $act_file_path;
                    }                   
                        
                    $this->Items_Model->_table_name = 'tbl_leads';
                    $this->Items_Model->_primary_key = 'leads_id';
                    $id = $this->Items_Model->save($data,$leads_id);
                
                    if($id)
                    {                 
                        // generate lead id
                        $year= date("Y");
                        $statePadded = sprintf("%02d", $this->input->post('state_id'));
                        $districtPadded = sprintf("%04d",$this->input->post('district_id'));
                        $idPadded = sprintf("%06d", $leads_id);
                        $code=$year.$statePadded.$districtPadded.$idPadded;
                        $lead_array = array('lead_number' => $code );
                        // update lead table 
                        $u_data['lead_number'] = $code;
                        $rows = $this->Items_Model->save($u_data, $leads_id);

                        $action = 'activity_update_leads';
                        // added entry in activity table
                        $activity = array(
                            'user' => $this->input->post('user_id'),
                            'module' => 'leads',
                            'module_field_id' => $leads_id,
                            'activity' => $action,
                            'icon' => 'fa-rocket',
                            'link' => 'admin/leads/leads_details/' . $leads_id,
                            'value1' => $data['first_name'] . ' ' . $data['middle_name'] . ' ' . $data['last_name']
                        );
                        $this->Items_Model->_table_name = 'tbl_activities';
                        $this->Items_Model->_primary_key = 'activities_id';
                        $this->Items_Model->save($activity);

                        $response = array('success' => true, 'message' => 'Lead details updated successfully.');
                        echo json_encode($response);
                    }
                    else
                    {
                        $response = array('success' => false, 'message' => 'Something went wrong during updating record,please try after sometime');
                        echo json_encode($response);
                    }
                }
                else
                {
                    $response = array( 'success' => false, 'data' => '' , 'message' => ('Mobile number present in the system.'));
                    echo json_encode($response);
                }                
            }
            else
            {
                $response = array('success' => false, 'message' => (validation_errors()));
                echo json_encode($response);
            }
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }
    
	public function save_website_lead()
	{

		if (isset($_REQUEST['Contact_No']) OR isset($_REQUEST['Email'])) {
			$product_name = $_REQUEST['Solar_Product'];
			if ($product_name!='') {
				$product_info = $this->Items_Model->check_by(array('name' => $product_name), 'tbl_products');
				#print_r($product_info->product_id);
				$product_id = $product_info->product_id;
				$data['product_id'] = $product_id;
			}
			if ($_REQUEST['Name']!='') {
				$namearr = explode(' ',$_REQUEST['Name']);
				if (count($namearr) == 1) {
					$data['first_name'] = trim($namearr[0]);
				}
				elseif (count($namearr) == 2) {
					$data['first_name'] = trim($namearr[0]);
					$data['last_name'] = trim($namearr[1]);
				}
				elseif (count($namearr) == 3) {
					$data['first_name'] = trim($namearr[0]);
					$data['middle_name'] = trim($namearr[1]);
					$data['last_name'] = trim($namearr[2]);
				}
			}

			$data['mobile'] = $_REQUEST['Contact_No'];
			$data['cust_message'] = $_REQUEST['Description'];
			$data['type'] = 'Lead';
			$data['lead_status'] = 'New';
			$data['lead_type'] = 'Hot';
			$data['email'] = $_REQUEST['Email'];
			
			if ($_REQUEST['Email']=='' && $_REQUEST['Contact_No']!='') {
				$mobile_no = $_REQUEST['Contact_No'];
				$message = 'Thank you for contacting AFM Solar System. Our Team will get in touch with you shortly.';
				
				$this->items_model->sendSMSByMakeMySMS($mobile_no,$message);
			}

			$this->items_model->_table_name = 'tbl_leads';
			$this->items_model->_primary_key = 'leads_id';

			$return_id = $this->items_model->save($data);

			$id = $return_id;
			$action = 'New Lead added from website';
			$activity = array(
			'user' => 0,
			'module' => 'leads',
			'module_field_id' => $id,
			'activity' => $action,
			'icon' => 'fa-rocket',
			'link' => '' ,
			'value1' => $data['first_name'] . ' ' . $data['middle_name'] . ' ' . $data['last_name']
			);
			$this->items_model->_table_name = 'tbl_activities';
			$this->items_model->_primary_key = 'activities_id';
			$this->items_model->save($activity);
			$temp = json_encode($_REQUEST);
			$str = array('installer_flag'=>$temp);
			$this->items_model->_table_name = 'tbl_installer';
			$this->items_model->_primary_key = 'id';
			$this->items_model->save($str);
			
		}
		else {
			echo 'else';
			$temp = json_encode($_REQUEST);
			$str = array('installer_flag'=>$temp);
			$this->items_model->_table_name = 'tbl_installer';
			$this->items_model->_primary_key = 'id';
			$this->items_model->save($str);
		}
	}

    public function lead_reassign_to_head()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $this->form_validation->set_rules('lead_id', 'Lead Id','trim|required');
            $this->form_validation->set_rules('user_id', 'User Id','trim|required');
            if ($this->form_validation->run() == true) 
            {
                $lead_id = $this->input->post('lead_id');
                $user_id = $this->input->post('user_id');
                $leads_info = $this->Items_Model->check_by(array('leads_id' => $lead_id), 'tbl_leads');              
                $data = array(
                    'lead_status' => 'Ready To Reassign',
                    'salesmanager_comment' => $this->input->post('comment'),
                    'assigned_to' => Null,
                    'updated_by' => $user_id,
                    'updated_date' => date('Y-m-d H:i:s'),
                );
                $this->Items_Model->_table_name = 'tbl_leads';
                $this->Items_Model->_primary_key = 'leads_id';
                $id = $this->Items_Model->save($data,$lead_id);
                if($id)
                {
                    if($leads_info->is_appointment == 'Yes')
                    {
                        // clear assigned_to value
                        $appo_data = array(
                            'assigned_to' => NULL,
                            'updated_by' => $user_id,
                            'updated_date' => date('Y-m-d H:i:s')
                        );
                        $this->db->where('leads_id',$lead_id);
                        $this->db->update('tbl_leads_appointment',$appo_data);
                    }

                    // added in activity table
                    $action = 'Ready To Reassign';
                    $activity = array(
                        'user' => 0,
                        'module' => 'leads',
                        'module_field_id' => $id,
                        'activity' => $action,
                        'icon' => 'fa-rocket',
                        'link' => '' ,
                        'value1' => $this->input->post('comment')
                    );
                    $this->items_model->_table_name = 'tbl_activities';
                    $this->items_model->_primary_key = 'activities_id';
                    $this->items_model->save($activity);

                    $response = array('success' => true, 'message' => 'Lead reassign to head successfully.');
                    echo json_encode($response);
                }
            }
            else
            {
                $response = array('success' => false, 'message' => (validation_errors()));
                echo json_encode($response);
            }
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);   
        }
    }

    public function updateLeadStatus()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if ($receivedTokan == $this->token) 
        {
            $this->form_validation->set_rules('user_id', 'User Id','trim|required');
            $this->form_validation->set_rules('lead_status', 'Lead Status','trim|required');
            $this->form_validation->set_rules('leads_id', 'Lead Id','trim|required');
            if ($this->form_validation->run() == true) 
            {
                $lead_data = array(
                    'lead_status' => $this->input->post('lead_status'),
                    'updated_by' => $this->input->post('user_id'),
                    'updated_date' => date('Y-m-d H:i:s')
                );

                $this->Items_Model->_table_name = 'tbl_leads';
                $this->Items_Model->_primary_key = 'leads_id';
                $id = $this->Items_Model->save($lead_data,$this->input->post('leads_id'));  
                if($id)
                {
                    if($this->input->post('lead_status') == 'Quotation Approved' || $this->input->post('lead_status') == 'Request For Regenerate Quotation')
                    {
                        // update quotation status to approve
                        $leads_info = $this->Items_Model->check_by(array('leads_id' => $this->input->post('leads_id')), 'tbl_leads');
                        if($leads_info->shared_quotation_id)
                        {
                            if($this->input->post('lead_status') == 'Quotation Approved')
                            {
                                $quo['quotation_status'] = 'Approved';
                            }
                            else if($this->input->post('lead_status') == 'Request For Regenerate Quotation')
                            {
                                $quo['quotation_status'] = 'Rejected';
                            }
                            
                            $this->Items_Model->_table_name = 'tbl_quotations';
                            $this->Items_Model->_primary_key = 'quotations_id';
                            $returnid = $this->Items_Model->save($quo,$leads_info->shared_quotation_id);
                            if($returnid)
                            {
                                // added entry in activity table
                                $action = $this->input->post('lead_status');
                                $activity = array(
                                    'user' => $this->input->post('user_id'),
                                    'module' => 'leads',
                                    'module_field_id' => $this->input->post('leads_id'),
                                    'activity' => $action,
                                    'icon' => 'fa-rocket',
                                    'link' => '',
                                );
                                $this->Items_Model->_table_name = 'tbl_activities';
                                $this->Items_Model->_primary_key = 'activities_id';
                                $this->Items_Model->save($activity);

                                $response = array('success' => true, 'message' => 'Lead status changed successfully');
                                echo json_encode($response);
                            }
                            else
                            {
                                $response = array('success' => false, 'message' => 'Something went wrong during update quotation, please try after sometime.');
                                echo json_encode($response);
                            }
                        }
                    }
                    else
                    {
                        $response = array('success' => true, 'message' => 'Lead status changed successfully');
                        echo json_encode($response);
                    }
                }
                else
                {
                    $response = array('success' => false, 'message' => 'Something went wrong during update lead, please try after sometime.');
                    echo json_encode($response);
                }
            }
            else 
            {
                $response = array('success' => false, 'message' => (validation_errors()));
                echo json_encode($response);
            }
        } 
        else 
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }	
}









