<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Salespersonapi extends MY_Controller
{

    public function __construct()
    {
        parent::__construct();         
        $this->load->model( 'rest_api_models/Salesperson_Model' );
		$this->load->model( 'rest_api_models/Common_Model' );
        $this->load->library('form_validation');
    }

    public function updateSalesmanLocation()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $this->form_validation->set_rules('salesman_id', 'Salesman Id','trim|required');
            if ($this->form_validation->run() == true) 
            {
                $data = array(
                    'latitude'=> $this->input->post('latitude'),
                    'longitude' => $this->input->post('longitude'),
                    'status' => $this->input->post('status'),
                    'date' => date('Y-m-d H:i:s')
                );

                $salesman_id = $this->input->post('salesman_id');
                $result = $this->Salesperson_Model->addSalesmanCurrentLocation($data, $salesman_id);
                if($result)
                {
                    $response = array('success' => true, 'message' => ("Successfully Stored"));
                }
                else
                {
                    $response = array('success' => false, 'message' => ("Something went wrong while inserting record,try after sometime."));
                }
            }
            else
            {
                $response = array('success' => false, 'message' => (validation_errors()));
            }

            echo json_encode($response);
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }             

    public function updateSalesmanStatus()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $this->form_validation->set_rules('salesman_id', 'Salesman Id','trim|required');
            if ($this->form_validation->run() == true) 
            {
                $data = array(
                    'status' => $this->input->post('status'),
                    'date' => date('Y-m-d H:i:s'),
                );
                $salesman_id = $this->input->post('salesman_id');
                $result = $this->Salesperson_Model->addSalesmanCurrentLocation($data, $salesman_id);
                if($result)
                {
                    $response = array('success' => true, 'message' => ("Status Updated uccessfully"));
                }
                else
                {
                    $response = array('success' => false, 'message' => ("Something went wrong during updating status,Please try after sometime."));
                }
            }
            else
            {
                $response = array('success' => false, 'message' => (validation_errors()));
            }
            echo json_encode($response);
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }          

    // book apointment
    public function book_appointment()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            if($this->input->post('appointment_id'))
            {
                // update appointment as reschedule
                $resch_app = array(
                    'status' => 'Rescheduled',
                    'updated_by' => $this->input->post('user_id'),
                    'updated_date' => date('Y-m-d H:i:s'),
                    'comment' => $this->input->post('comment'),
                    'assigned_to' => NULL
                );
                $this->Salesperson_Model->_table_name = 'tbl_leads_appointment';
                $this->Salesperson_Model->_primary_key = 'id';
                $result = $this->Salesperson_Model->save($resch_app,$this->input->post('appointment_id'));
                if($result)
                {
                    $created_by = $this->input->post('user_id');
                    $action = 'Appointment has been rescheduled.';
                    // added entry in activity table
                    $activity = array(
                        'user' => $created_by,
                        'module' => 'leads',
                        'module_field_id' => $this->input->post('leads_id'),
                        'activity' => $action,
                        'icon' => 'fa-rocket',
                    );
                    $this->Salesperson_Model->_table_name = 'tbl_activities';
                    $this->Salesperson_Model->_primary_key = 'activities_id';
                    $this->Salesperson_Model->save($activity);
                }
            }

            if($this->input->post('type') == 'Appointment')
            {
                // add appointment
                $this->form_validation->set_rules('user_id', 'User Id','trim|required');
                $this->form_validation->set_rules('leads_id', 'Leads Id','trim|required');
                $this->form_validation->set_rules('appointment_time', 'Appointment Time','trim|required');
                $this->form_validation->set_rules('appointment_address', 'Appointment Address','trim|required');
                if ($this->form_validation->run() == true) 
                {
                    $data = array(
                        'leads_id' => $this->input->post('leads_id'),
                        'appointment_time' => $this->input->post('appointment_time'),
                        'appointment_address' => $this->input->post('appointment_address'),
                        'status' => 'Scheduled',
                        'assigned_to' => $this->input->post('user_id'),
                        'type' => $this->input->post('type')
                    );
                }
                else
                {
                    $response = array('success' => false, 'message' => (validation_errors()));
                    echo json_encode($response);
                }
            }
            else if($this->input->post('type') == 'Follow Up')
            {
                $data = array(
                    'leads_id' => $this->input->post('leads_id'),
                    'appointment_time' => $this->input->post('appointment_time') ? $this->input->post('appointment_time') : NULL,
                    'appointment_address' => $this->input->post('appointment_address'),
                    'status' => 'Scheduled',
                    'assigned_to' => $this->input->post('user_id')
                );
            }
            // check duplicate 
            $dupresult = false;
            if(!empty($this->input->post('appointment_time')) && $this->input->post('appointment_address'))
            {
                $dupresult = $this->Salesperson_Model->checkduplicate($data);
            }            
            if(!$dupresult)
            {
                $data['comment'] = $this->input->post('comment');
                $data['created_by'] = $this->input->post('user_id');
                $data['type'] = $this->input->post('type');
                $data['created_date'] = date('Y-m-d H:i:s');
                $result = $this->Salesperson_Model->addappointment($data);
                if($result)
                {
                    if(empty($this->input->post('appointment_id')))
                    {
                        if($this->input->post('type')!='Follow Up')
                        {
                            // update lead table
                            $lead_data = array(
                                'is_appointment' => 'Yes',
                                'updated_by' => $this->input->post('user_id'),
                                'updated_date' => date('Y-m-d H:i:s')
                            );
                            $this->Salesperson_Model->_table_name = 'tbl_leads';
                            $this->Salesperson_Model->_primary_key = 'leads_id';
                            $this->Salesperson_Model->save($lead_data,$this->input->post('leads_id'));
                        }
                        
                        $created_by = $this->input->post('user_id');
                        $action = 'activity_add_appointment';
                        // added entry in activity table
                        $activity = array(
                            'user' => $created_by,
                            'module' => 'leads',
                            'module_field_id' => $this->input->post('leads_id'),
                            'activity' => $action,
                            'icon' => 'fa-rocket',
                        );
                        $this->Salesperson_Model->_table_name = 'tbl_activities';
                        $this->Salesperson_Model->_primary_key = 'activities_id';
                        $this->Salesperson_Model->save($activity);
                        $response = array('success' => true, 'data' => $result, 'message' => ("Appointment added successfully."));
                        echo json_encode($response);
                    }
                    else
                    {
                        $response = array('success' => true, 'data' => $result, 'message' => ("Appointment rescheduled successfully."));
                            echo json_encode($response);
                    }                       
                }
                else
                {
                    $response = array('success' => false, 'message' => ("Something went wrong during add appointment, please try after sometime."));
                        echo json_encode($response);
                }
            }
            else
            {
                $response = array('success' => false, 'message' => ("Appointment is already present."));
                echo json_encode($response);
            }              
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }

    public function getAllAppointments()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $this->form_validation->set_rules('user_id', 'User Id','trim|required');
            if ($this->form_validation->run() == true) 
            {
                $user_id = $this->input->post('user_id');
               $appointment_list = $this->Salesperson_Model->getAllAssignedAppointments($user_id);
                if($appointment_list)
                {
                    $response=array('success' => true, 'data'=>$appointment_list);
                    echo json_encode($response);
                }
                else
                {
                    $response=array('success' => false, 'message'=>'No data available in table.');
                    echo json_encode($response);
                }
            }
            else
            {
                $response = array('success' => false, 'message' => (validation_errors()));
                echo json_encode($response);
            }
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }

    public function updatestatus()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $this->form_validation->set_rules('user_id', 'User Id','trim|required');
            $this->form_validation->set_rules('appointment_id', 'Appointment Id','trim|required');
            $this->form_validation->set_rules('status', 'Status','trim|required');
            if ($this->form_validation->run() == true) 
            {
                $user_id = $this->input->post('user_id');
                $status = $this->input->post('status');
                $id = $this->input->post('appointment_id');
                $data = array(
                    'status' => $status,
                    'comment' => $this->input->post('comment'),
                    'updated_by' => $user_id,
                    'updated_date' => date('Y-m-d H:i:s')
                );
                $this->Salesperson_Model->_table_name = 'tbl_leads_appointment';
                $this->Salesperson_Model->_primary_key = 'id';
                $id = $this->Salesperson_Model->save($data, $id);
                if($id)
                {
                    $action = 'activity_update_appointment';
                    // added entry in activity table
                     $activity = array(
                        'user' => $user_id,
                        'module' => 'leads',
                        'module_field_id' => $id,
                        'activity' => $action,
                        'icon' => 'fa-rocket',
                    );
                    $this->Salesperson_Model->_table_name = 'tbl_activities';
                    $this->Salesperson_Model->_primary_key = 'activities_id';
                    $this->Salesperson_Model->save($activity);
                    $response = array('success' => true, 'message' => ("Appointment updated successfully."));
                    echo json_encode($response);
                }
                else
                {
                    $response = array('success' => false, 'message' => ("Something went wrong during update appointment, please try after sometime."));
                        echo json_encode($response);
                }
            }
            else
            {
                $response = array('success' => false, 'message' => (validation_errors()));
                echo json_encode($response);
            }
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }

    public function update_appointment()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $this->form_validation->set_rules('user_id', 'User Id','trim|required');
            $this->form_validation->set_rules('appointment_id', 'Appointment Id','trim|required');
            $this->form_validation->set_rules('appointment_time', 'Appointment Time','trim|required');
            $this->form_validation->set_rules('appointment_address', 'Appointment Address','trim|required');
            if ($this->form_validation->run() == true) 
            {
                $id = $this->input->post('appointment_id');
                $data = array(
                    'leads_id' => $this->input->post('leads_id'),
                    'appointment_time' => $this->input->post('appointment_time'),
                    'appointment_address' => $this->input->post('appointment_address'),
                    'updated_by' => $this->input->post('user_id'),
                    'updated_date' => date('Y-m-d H:i:s')
                );

                $this->Salesperson_Model->_table_name = 'tbl_leads_appointment';
                $this->Salesperson_Model->_primary_key = 'id';
                $id = $this->Salesperson_Model->save($data, $id);
                if($id)
                {
                    $action = 'activity_update_appointment';
                    // added entry in activity table
                     $activity = array(
                        'user' => $user_id,
                        'module' => 'leads',
                        'module_field_id' => $id,
                        'activity' => $action,
                        'icon' => 'fa-rocket',
                    );
                    $this->Salesperson_Model->_table_name = 'tbl_activities';
                    $this->Salesperson_Model->_primary_key = 'activities_id';
                    $this->Salesperson_Model->save($activity);
                    $response = array('success' => true, 'message' => ("Appointment updated successfully."));
                    echo json_encode($response);
                }
                else
                {
                    $response = array('success' => false, 'message' => ("Something went wrong during update appointment, please try after sometime."));
                        echo json_encode($response);
                }
            }
            else
            {
                $response = array('success' => false, 'message' => (validation_errors()));
                echo json_encode($response);
            }
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }

    public function getLeadById()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $this->form_validation->set_rules('leads_id', 'Lead Id','trim|required');
            if ($this->form_validation->run() == true) 
            {
                $leads_id = $this->input->post('leads_id');
                $leads_information = $this->items_model->check_by(array('leads_id' => $leads_id), 'tbl_leads');
                if($leads_information)
                {
                    $response = array('success' => true, 'data' => $leads_information);
                    echo json_encode($response);
                }
                else
                {
                    $response = array('success' => false, 'message' => 'No record found.');
                    echo json_encode($response);
                }
            }
            else
            {
                $response = array('success' => false, 'message' => (validation_errors()));
                echo json_encode($response);
            }
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }

    public function getSalesmanRoutes()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $this->form_validation->set_rules('salesman_id', 'Salesman Id','trim|required');
            if ($this->form_validation->run() == true) 
            {
                $salesman_id = $this->input->post('salesman_id');
                $page = $this->input->post('page');
                $fromDate = $this->input->post('fromDate');
                $toDate = $this->input->post('toDate');
                $startLimit = ($page - 1)* 10;
                $lastLimit = $page * 10;

                $routes = $this->Salesperson_Model->getSalesmanRoutes($salesman_id, $startLimit, $lastLimit, $fromDate, $toDate);
                if($routes)
                {
                    $data['routes'] = $routes;
                    $response = array('success' => true, 'data' => $data, 'message' => ("Successfully"));
                }
                else
                {
                    $response = array('success' => false, 'message' => ("No Routes found"));
                }
            }
            else
            {
                $response = array('success' => false, 'message' => (validation_errors()));
            }
            echo json_encode($response);
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }        
    }
	
	//store salesman route info
	public function store_saleman_route()
	{

		$username = $this->input->post('email');
		$password = $this->input->post('password');
		$offlineRouteId = $this->input->post('offlineRouteId');
		$company_id = $this->input->post('company_id');

	/*if($this->authenticateUser_model->authenticateUser($username, $password))
	{*/
		$data=array(
		'salesman_id' =>$this->input->post('salesman_id'),
		'end_time'=>  $this->input->post('end_time'),
		'start_time'=>  $this->input->post('start_time'),
		'distance' => $this->input->post('distance'),
		);
		$end_date = date('Y-m-d',strtotime($this->input->post('end_time')));
		$salesman = $this->input->post('salesman_id');
		$distance = $this->input->post('distance');
		$return_data = $this->Salesperson_Model->checkRoutePresentOrNot($data);
		$duplicateDist = $this->Salesperson_Model->checkDistancePresentForSameDate($salesman,$end_date,$distance);

		if ($return_data || $duplicateDist) {
			$response = array('success' => false, 'message' => ("This route is present already"));
			echo json_encode($response);
		} else {
			$post_params = array('salesman_id' =>$this->input->post('salesman_id'),
			//'end_time'=>  $date = date('Y-m-d H:i:s'),
			'end_time'=>  $this->input->post('end_time'),   //end_time
			'start_time'=>  $this->input->post('start_time'),
			'route_info' => $this->input->post('route_info'),
			'start_address' => $this->input->post('start_address'),
			'end_address' => $this->input->post('end_address'),
			'distance' => $this->input->post('distance'),
			'end_date' => $end_date,
			'bit_id' => $this->input->post('bit_id')
			);

			$result = $this->Salesperson_Model->add_salesman_route($post_params, $company_id);

			if ($result) {
				$response = array('success' => true, 'offlineRouteId' => $offlineRouteId , 'data' => $result, 'message' => ("Successfully stored"));
			} else {
				$response = array('success' => false, 'message' => ("Something went wrong"));
			}

			echo json_encode($response);
		}
	/*}else{
	$response = array('success' => false, 'message' => ("You are not allowded to do that"));
	echo json_encode($response);
	}*/
	}

    public function getQuotationsByMobile()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $this->form_validation->set_rules('mobile', 'Mobile Number','trim|required');
            if ($this->form_validation->run() == true) 
            {
                $mobile = $this->input->post('mobile');
                $result = $this->Salesperson_Model->getQuotationsByMobile($mobile);
                if($result)
                {
                    $response = array('success' => true, 'data' => $result);
                }
                else
                {
                    $response = array('success' => false, 'message' => 'No data found');
                }
            }
            else
            {
                $response = array('success' => false, 'message' => (validation_errors()));
            }
            echo json_encode($response);
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }

    public function getAppointmentByLeadId()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $this->form_validation->set_rules('lead_id', 'Lead Id','trim|required');
            $this->form_validation->set_rules('type', 'Type','trim|required');
            if ($this->form_validation->run() == true) 
            {
                $lead_id = $this->input->post('lead_id');
                $type = $this->input->post('type');
                $result = $this->Salesperson_Model->getAppointmentsByLeadId($lead_id,$type);
                if($result)
                {
                    $response = array('success' => true, 'data' => $result);
                }
                else
                {
                    $response = array('success' => false, 'message' => 'No data found');
                }
            }
            else
            {
                $response = array('success' => false, 'message' => (validation_errors()));
            }
            echo json_encode($response);
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }    


    // reschedule appointment of lead
    public function reschedule_appointment()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if($receivedTokan == $this->token)
        {
            $this->form_validation->set_rules('user_id', 'User Id','trim|required');
            $this->form_validation->set_rules('appointment_id', 'Appointment Id','trim|required');
            $this->form_validation->set_rules('appointment_time', 'Appointment Time','trim|required');
            $this->form_validation->set_rules('appointment_address', 'Appointment Address','trim|required');
            if ($this->form_validation->run() == true) 
            {
                $appointment_id = $this->input->post('appointment_id');
                $leads_id = $this->input->post('leads_id');
                $data = array(
                    'appointment_time' => $this->input->post('appointment_time'),
                    'appointment_address' => $this->input->post('appointment_address'),
                    'status' => 'Rescheduled',
                    'updated_by' => $this->input->post('user_id'),
                    'updated_date' => date('Y-m-d H:i:s')
                );
                if(!empty($this->input->post('comment')))
                {
                    $data['comment'] = $this->input->post('comment');
                }
                
                $this->Salesperson_Model->_table_name = 'tbl_leads_appointment';
                $this->Salesperson_Model->_primary_key = 'id';
                $result = $this->Salesperson_Model->save($data,$appointment_id);
                if($result)
                {
                    $created_by = $this->input->post('user_id');
                    $action = 'Appointment has been rescheduled.';
                    // added entry in activity table
                    $activity = array(
                        'user' => $created_by,
                        'module' => 'leads',
                        'module_field_id' => $leads_id,
                        'activity' => $action,
                        'icon' => 'fa-rocket',
                    );
                    $this->Salesperson_Model->_table_name = 'tbl_activities';
                    $this->Salesperson_Model->_primary_key = 'activities_id';
                    $this->Salesperson_Model->save($activity);
                    $response = array('success' => true, 'data' => $result, 'message' => ("Appointment rescheduled successfully."));
                    echo json_encode($response);
                }
                else
                {
                    $response = array('success' => false, 'message' => ("Something went wrong during reschedule appointment, please try after sometime."));
                    echo json_encode($response);
                }               
            }
            else
            {
                $response = array('success' => false, 'message' => (validation_errors()));
                echo json_encode($response);
            }
        }
        else
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }

    
	public function getSalesManagerDashboardCounts()
	{
		$receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
		//echo 'received ='. $receivedTokan;
		//echo 'set token='. $this->token;die;
		if ($receivedTokan == $this->token) {
			$this->form_validation->set_rules('user_id', 'User Id','trim|required');
			if ($this->form_validation->run() == true) {
				$user_id = $this->input->post('user_id');
				$where1 = 'assigned_to='.$user_id;
				$assigned_lead_count = $this->Salesperson_Model->count_rows('tbl_leads',$where1);
				$final_array = array();
				$final_array= array('assigned_lead_count'=>$assigned_lead_count);
				$where2 = "assigned_to=".$user_id." AND DATE_FORMAT(appointment_time,'%Y-m-d') ='".date('Y-m-d')."'";
				$lead_appointment_count = $this->Salesperson_Model->count_rows('tbl_leads_appointment',$where2);
				
				$final_array['lead_appoinment_count'] = $lead_appointment_count;

				$response = array('success' => true, 'data' => $final_array);
				echo json_encode($response);

			} else {
				$response = array('success' => false, 'message' => (validation_errors()));
				echo json_encode($response);
			}
		} else {
			$response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
			echo json_encode($response);
		}
	}

    // this function is used for update quotation status
    public function changestatus()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if ($receivedTokan == $this->token) 
        {
            $this->form_validation->set_rules('user_id', 'User Id','trim|required');
            $this->form_validation->set_rules('quotation_id', 'Quotation Id','trim|required');
            $this->form_validation->set_rules('leads_id', 'Lead Id','trim|required');
            if ($this->form_validation->run() == true) 
            {
                $quotation_data = array(
                    'quotation_status' => $this->input->post('status'),
                    'updated_by' => $this->input->post('user_id'),                    
                    'updated_date' => date('Y-m-d H:i:s')
                );
                $this->Salesperson_Model->_table_name = 'tbl_quotations';
                $this->Salesperson_Model->_primary_key = 'quotations_id';
                $return_id = $this->Salesperson_Model->save($quotation_data,$this->input->post('quotation_id'));
                if($return_id && $this->input->post('status')=='Shared')
                {
                    // add shared quotation id into lead table
                    $sharedquo['shared_quotation_id'] = $this->input->post('quotation_id');
                    $sharedquo['lead_status'] = 'Quotation Sent';
                    $this->Salesperson_Model->_table_name = 'tbl_leads';
                    $this->Salesperson_Model->_primary_key = 'leads_id';
                    $id = $this->Salesperson_Model->save($sharedquo,$this->input->post('leads_id'));
                    if($id)
                    {
                        $response = array('success' => true, 'message' => 'Quotation status changed successfully.');
                        echo json_encode($response);
                    }
                    else
                    {
                        $response = array('success' => false, 'message' => 'Something went wrong during update lead, please try after sometime.');
                        echo json_encode($response);
                    }
                }
                else
                {
                    $response = array('success' => false, 'message' => 'Something went wrong during update status, please try after sometime.');
                    echo json_encode($response);
                }
            }
            else 
            {
                $response = array('success' => false, 'message' => (validation_errors()));
                echo json_encode($response);
            }
        } 
        else 
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }

    public function addEditExpense()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if ($receivedTokan == $this->token) 
        {
            $this->form_validation->set_rules('name', 'Name','trim|required');
            $this->form_validation->set_rules('date', 'Date','trim|required');
            $this->form_validation->set_rules('amount', 'Amount','trim|required');
            $this->form_validation->set_rules('category_id', 'Category','trim|required');
            if ($this->form_validation->run() == true) 
            {
                $expense_id = $this->input->post('expense_id') ? $this->input->post('expense_id') : '';
                $data = array(
                    'name' => $this->input->post('name'),
                    'date' => $this->input->post('date'),
                    'category_id' => $this->input->post('category_id'),
                    'amount' => $this->input->post('amount'),
                    'payment_methods_id' => $this->input->post('payment_methods_id'),
                    'type' => 'Expense',
                    'notes' => $this->input->post('notes')
                );
                if(!empty($expense_id))
                {
                    $data['updated_date'] = date('Y-m-d H:i:s');
                    $data['updated_by'] = $this->input->post('user_id');
                }
                else
                {
                    $data['create_date'] = date('Y-m-d H:i:s');
                    $data['added_by'] = $this->input->post('user_id');
                }
                $is_file_attached = $this->input->post('is_file_attached');
                $act_file_path = "";
                if($is_file_attached == '1')
                {
                    if(!empty($expense_id))
                    {
                        // delete old file
                        $expense_info = $this->Salesperson_Model->check_by(array('transactions_id' => $expense_id),'tbl_transactions');
                        if($expense_info->attachement)
                        {
                            $file_info = json_decode($expense_info->attachement);
                            if(file_exists($file_info[0]->path))
                            {
                                unlink($file_info[0]->path);
                            }
                        }
                    }
                    upload_file_to_temp();
                    $upload_file = array();
                    $target_path = getcwd() . "/uploads/";                   
                    $file_name = $_FILES['file']['name'];
                    $new_file_name = move_temp_file($file_name, $target_path);
                    $file_ext = explode(".", $new_file_name);
                    $is_image = check_image_extension($new_file_name);
                    $size = $this->input->post('file_size') / 1000;
                    if ($new_file_name) 
                    {
                        $up_data = array(
                            "fileName" => $new_file_name,
                            "path" => "uploads/" . $new_file_name,
                            "fullPath" => getcwd() . "/uploads/" . $new_file_name,
                            "ext" => '.' . end($file_ext),
                            "size" => round($size, 2),
                            "is_image" => $is_image,
                        );
                        array_push($upload_file, $up_data);
                    }
                }
                if (!empty($upload_file)) {
                    $data['attachement'] = json_encode($upload_file);
                } else {
                    $data['attachement'] = null;
                }

                $this->Salesperson_Model->_table_name = "tbl_transactions"; //table name
                $this->Salesperson_Model->_primary_key = "transactions_id";
                if($expense_id)
                {
                    $id = $this->Salesperson_Model->save($data,$expense_id);
                    $message = lang('update_a_expense');
                    $activity = ('activity_update_expense');
                }
                else
                {
                    $id = $this->Salesperson_Model->save($data);
                    $activity = ('activity_new_expense');
                    $message = lang('save_new_expense');
                }
                
                if($id)
                {
                    // added in activity table                    
                    $activities = array(
                        'user' => $this->input->post('user_id'),
                        'module' => 'transactions',
                        'module_field_id' => $id,
                        'activity' => $activity,
                        'icon' => 'fa-building-o',
                        'link' => 'admin/transactions/view_details/' . $id,
                        'value2' => $data['amount'],
                    );
                    // Update into tbl_project
                    $this->Salesperson_Model->_table_name = "tbl_activities"; //table name
                    $this->Salesperson_Model->_primary_key = "activities_id";
                    $this->Salesperson_Model->save($activities);

                    $response = array('success' => true, 'message' => $message);
                    echo json_encode($response);                    
                }
                else
                {
                    $response = array('success' => false, 'message' => 'Something went wrong during inserting expense, please try after sometime.');
                    echo json_encode($response);
                }
            }
            else 
            {
                $response = array('success' => false, 'message' => (validation_errors()));
                echo json_encode($response);
            }
        }
        else 
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }      

    public function getAllAddedExpenses()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if ($receivedTokan == $this->token) 
        {
            $this->form_validation->set_rules('user_id', 'User Id','trim|required');
            if ($this->form_validation->run() == true) 
            {
                $user_id = $this->input->post('user_id');
                $where = array('added_by' => $user_id,'type' => 'Expense');
                $expense_list = $this->Salesperson_Model->get_result($where,'tbl_transactions');
                if($expense_list)
                {
                    $response = array('success' => true, 'data' => $expense_list);
                    echo json_encode($response);
                }
                else
                {
                    $response = array('success' => false, 'message' => 'No record found.');
                    echo json_encode($response);
                }                           
            }
            else 
            {
                $response = array('success' => false, 'message' => (validation_errors()));
                echo json_encode($response);
            }
        }
        else 
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }

    public function getExpenseById()
    {
        $receivedTokan = $this->input->post('token') ? $this->input->post('token') : '';
        if ($receivedTokan == $this->token) 
        {
            $this->form_validation->set_rules('expense_id', 'Expense Id','trim|required');
            if ($this->form_validation->run() == true) 
            {
                $transactions_id = $this->input->post('expense_id');
                $where = array('transactions_id' => $transactions_id);
                $expense_details = $this->Salesperson_Model->check_by($where,'tbl_transactions');
                if($expense_details)
                {
                    $response = array('success' => true, 'data' => $expense_details);
                    echo json_encode($response);
                }
                else
                {
                    $response = array('success' => false, 'message' => 'No record found.');
                    echo json_encode($response);
                }           
            }
            else 
            {
                $response = array('success' => false, 'message' => (validation_errors()));
                echo json_encode($response);
            }
        }
        else 
        {
            $response = array('success' => false, 'message' => ("You have provided an invalid token,Please provide valid token"));
            echo json_encode($response);
        }
    }
                  
}









