<?php
class Common_Model extends MY_Model
{

	public function getUserDetails($email, $password)
	{
		$hashpassword = $this->hash($password);
		$myQuery = "SELECT tbl_users.*,tbl_account_details.*,tbl_designations.designations,tbl_departments.deptname FROM tbl_users JOIN tbl_account_details ON tbl_account_details.user_id = tbl_users.user_id JOIN tbl_designations ON tbl_designations.designations_id = tbl_account_details.designations_id JOIN tbl_departments ON tbl_departments.departments_id = tbl_designations.departments_id WHERE (tbl_users.email = '". $email ."' OR tbl_users.username ='". $email ."' ) AND tbl_users.password = '". $hashpassword ."'";
        
        $query = $this->db->query($myQuery);
		if($query->num_rows() > 0)
		{
			return $query->row();
		}
		else
		{
			return false;
		}		
	}

	public function updatePassword( $post ) 
	{
		$this->db->where( 'id', $post[ 'id' ] );
		$this->db->update( 'staff', array( 'password' => $post[ 'password' ] ) );
		$success = $this->db->affected_rows();

		if ( !$success ) {
			return false;
		}
		return true;
	}

	public function getUserDetailsByEmail($email)
	{
		$q = $this->db->get_where( 'staff', array( 'email' => $email ), 1 );
		if ( $this->db->affected_rows() > 0 ) {
			$row = $q->row_array();
			return $row;
		} else {
			return false;
		}
	}

	public function updateLoginStatusData($statusData, $user_id)
	{
		$this->db->select('*')
            ->from('tbl_users')
            ->where(array('user_id'=> $user_id));    //get user by id

        $query= $this->db->get();
        if($query->num_rows()>0)
        {    //id use id present
            $this->db->where(array( 'user_id' => $user_id ));
            $this->db->update( 'tbl_users' , $statusData );    //update login status
            return true;
        }
        return false;
    }

    // Update profile
   public  function updateProfile($params, $id)
    {
    	$this->db->where( 'user_id', $id );
		$response = $this->db->update( 'tbl_users', $params );
		if ($response) 
		{
			return true;
		}
		else
		{
			return false;
		}
    }

    // for password hash
    public function hash($string)
    {
        return hash('sha512', $string . config_item('encryption_key'));
    }

    public function get_user_designation_id($user_id)
    {
    	$this->db->select( 'tbl_account_details.designations_id,tbl_designations.designations' );
		$this->db->from( 'tbl_users' );
		$this->db->join( 'tbl_account_details', 'tbl_account_details.user_id = tbl_users.user_id');
		$this->db->join( 'tbl_designations', 'tbl_designations.designations_id = tbl_account_details.designations_id');
		$this->db->where( 'tbl_users.user_id' , $user_id);
		$query = $this->db->get();
		if($query->num_rows() > 0)
		{
			return $query->row();
		}
		else
		{
			return false;
		}
    }

    public function get_menu_by_designation($designations_id)
    {
    	$this->db->select('tbl_menu.menu_id,tbl_menu.label')
    		->from('tbl_user_role')
    		->join('tbl_menu','tbl_menu.menu_id=tbl_user_role.menu_id')
    		->where('tbl_user_role.designations_id',$designations_id);
    	$query = $this->db->get();
    	if($query->num_rows() > 0)
    	{
    		foreach (($query->result()) as $row) {
                $data[] = $row;
            }
            return $data;
    	}
    	return false;
    }

    public function get_profile_details($user_id)
    {
    	$this->db->select( 'tbl_users.*,tbl_account_details.*,tbl_designations.designations,tbl_departments.deptname' );
		$this->db->from( 'tbl_users' );
		$this->db->join( 'tbl_account_details', 'tbl_account_details.user_id = tbl_users.user_id');
		$this->db->join( 'tbl_designations', 'tbl_designations.designations_id = tbl_account_details.designations_id');
		$this->db->join( 'tbl_departments', 'tbl_departments.departments_id = tbl_designations.departments_id');
		$this->db->where( 'tbl_users.user_id' , $user_id);
		$query = $this->db->get();
		if($query->num_rows() > 0)
		{
			return $query->row();
		}
		else
		{
			return false;
		}		
    }

    public function validate_user_password( $id, $password ) {
		$this->db->from( 'tbl_users' );
		$this->db->where( 'user_id', $id );
		$this->db->where( 'password', $password);
		$login = $this->db->get()->result();
		if ( is_array( $login ) && count( $login ) == 1 ) {
			return true;
		} else {
			return false;
		}
	}

	public function check_mobile_duplicate($mobile,$lead_id = NULL)
	{
		$status_array = array('New','Rescheduled','Not Responding','Convert To Customer','Picked','Assigned','Ready To Assign','Request For Quotation','Reassigned','Ready To Reassign','Request For Regenerate Quotation','Quotation Approved','Quotation Sent','Agreement Generated');
		$this->db->select('*');
		$this->db->from('tbl_leads');
		$this->db->where('mobile',$mobile);
		if($lead_id)
		{
		$this->db->where('leads_id!=',$lead_id);
		}
		$this->db->where_in('lead_status',$status_array);

		$query = $this->db->get();
		if($query->num_rows() > 0)
		{
			// duplicate mobile number
			return true;
		}
		else
		{
			// not duplicate mobile number
			return false;
		}
	}

	public function getAllRecords($table)
	{
		return $this->db->get($table)->result();
	}

	public function getCustomerDetails($email, $password)
	{
		$hashpassword = $this->hash($password);
		$myQuery = "SELECT * FROM tbl_client WHERE (tbl_client.email = '". $email ."' OR tbl_client.username ='". $email ."' ) AND tbl_client.password = '". $hashpassword ."'";
        
        $query = $this->db->query($myQuery);
		if($query->num_rows() > 0)
		{
			return $query->row();
		}
		else
		{
			return false;
		}		
	}
}
