<?php
class Salesperson_Model extends MY_Model
{
    public $_table_name;
    public $_order_by;
    public $_primary_key;
    
	function addSalesmanCurrentLocation($data, $salesman_id)
	{
		$this->db->select('*')
            ->from('tbl_salesman_current_location')
            ->where(array('salesman_id' => $salesman_id ));
        $query = $this->db->get();
        if($query->num_rows() > 0)
        {
            $this->db->where(array('salesman_id'=>$salesman_id));
            $this->db->update('tbl_salesman_current_location',$data);
            return true;
        }
        else
        {
        	$data['salesman_id'] = $salesman_id;
            $this->db->insert('tbl_salesman_current_location', $data);
            $insert_id = $this->db->insert_id();
            return true;
        }
		return false;
	}

    function checkduplicate($data)
    {
        $query = $this->db->get_where('tbl_leads_appointment',$data);
        if($query->num_rows() > 0)
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    function addappointment($data)
    {
        $this->db->insert('tbl_leads_appointment', $data);
        $insert_id = $this->db->insert_id();
        if($insert_id)
        {
            return $insert_id;
        }
        else
        {
            return false;
        }
    }

    function getAllAssignedAppointments($user_id)
    {
        $this->db->select('tbl_leads_appointment.*,tbl_leads.*,tbl_leads_appointment.type as appointment_type')
            ->from('tbl_leads_appointment')
            ->join('tbl_leads','tbl_leads.leads_id=tbl_leads_appointment.leads_id')
            ->where('tbl_leads_appointment.assigned_to',$user_id);
        $query = $this->db->get();
        if($query->num_rows() > 0)
        {
            foreach($query->result() as $row)
            {
                $data[] = $row;
            }
            return $data;
        }
        return false;
    }
    
	public function checkRoutePresentOrNot($data)
	{
		$query = $this->db->get_where('salesman_locations', $data);
		if ($query->num_rows() > 0) {
			return true;
		} else {
			return FALSE;
		}
	}
	
	public function checkDistancePresentForSameDate($salesman, $end_date, $distance)
	{
		$query = $this->db->get_where('salesman_locations',array('salesman_id' => $salesman,'end_date' => $end_date,'distance' => $distance));
		if ($query->num_rows() > 0) {
			return true;
		} else {
			return FALSE;
		}
	}
	public function add_salesman_route($data, $company_id)
	{

		$this->db->insert('salesman_locations', $data);
		$insert_id = $this->db->insert_id();

		//if ($insert_id && $this->utils_model->addAuditInformation($data['salesman_id'],$company_id,Utils_model::$add_route ,Utils_model::$add)) {
		if ($insert_id) {
			return true;
		} else {
			return false;
		}
	}
	
	public function getSalesmanRoutes ($salesman_id, $startLimit, $lastLimit, $fromDate, $toDate)
	{

		//SELECT * FROM `lw_salesman_locations` WHERE salesman_id = 35 AND
		// end_time >= '2018-09-06 00:00:01' AND end_time <= '2018-09-06 11:59:59'

		$this->db->select("*");
		$this->db->where('salesman_id' , $salesman_id);

		if ($fromDate !== "" && $toDate !== "" ) {
			$fromDate = $fromDate. " 00:00:01";
			$toDate = $toDate. " 23:59:59";

			$this->db->where('end_time >=',  $fromDate);
			$this->db->where('end_time <=', $toDate );
		}

		$this->db->order_by("id", "desc");
		$this->db->limit($lastLimit,$startLimit);

		$q = $this->db->get('salesman_locations');

		if ($q->num_rows() > 0) {
			foreach (($q->result()) as $row) {
				$data[] = $row;
			}
			return $data;
		}
		return FALSE;
	}

    public function getQuotationsByMobile($mobile)
    {
        $this->db->select('*')
            ->from('tbl_quotations')
            ->join('tbl_leads','tbl_leads.leads_id = tbl_quotations.lead_id')
            ->where('tbl_leads.mobile',$mobile)
            ->order_by('created_date','desc');
        $query = $this->db->get();
        if($query->num_rows() > 0)
        {
            foreach($query->result_array() as $row)
            {
                $data[] = $row;
            }
            return $data;
        }
        return false;
    }

    function getAppointmentsByLeadId($leads_id,$type)
    {
        $this->db->select('tbl_leads_appointment.*,tbl_leads.*,tbl_leads_appointment.type as appointment_type')
            ->from('tbl_leads_appointment')
            ->join('tbl_leads','tbl_leads.leads_id=tbl_leads_appointment.leads_id')
            ->where('tbl_leads_appointment.leads_id',$leads_id)
            ->where('tbl_leads_appointment.type',$type)
            ->order_by('tbl_leads_appointment.id','desc');
        $query = $this->db->get();
        if($query->num_rows() > 0)
        {
            foreach($query->result() as $row)
            {
                $data[] = $row;
            }
            return $data;
        }
        return false;
    }
}
