<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title><?= lang('quotation') ?></title>

    <?php
    $direction = $this->session->userdata('direction');
    if (!empty($direction) && $direction == 'rtl') {
        $RTL = 'on';
    } else {
        $RTL = config_item('RTL');
    }
    ?>
    <style type="text/css">
        @font-face {
            font-family: "Source Sans Pro", sans-serif;
        }

        .h4 {
            font-size: 18px;
        }

        .h3 {
            font-size: 24px;
        }

        p{
            font-size: 16px;
        }

        h2{
            font-size: 18px;
        }

        .clearfix:after {
            content: "";
            display: table;
            clear: both;
        }

        a {
            color: #0087C3;
            text-decoration: none;
        }

        body {
            color: #555555;
            background: #ffffff;
            font-size: 14px;
            font-family: "Source Sans Pro", sans-serif;
            width: 100%;
        <?php if(!empty($RTL)){?> text-align: right;
        <?php }?>
        }

        header {
            padding: 10px 10px;
            margin-bottom: 20px;
            /*border-bottom: 1px solid #aaaaaa;*/
            position: fixed;
            text-align: right;
            color: #6297d9;
        }

        #logo {
        <?php if(!empty($RTL)){?> text-align: right !important;
            padding-right: 55px;
        <?php }?>
        }

        h2.name {
            font-size: 1em;
            font-weight: normal;
            margin: 0;
        <?php if(!empty($RTL)){?> text-align: right;
        <?php }?>
        }

        table {
            width: 100%;
            border-spacing: 0;
        <?php if(!empty($RTL)){?> text-align: right;
        <?php }?>
        }

        footer {
            color: #6297d9;
            width: 100%;
            height: 50px;
            position: fixed;
            bottom: 0;
            border-top: 1px solid #aaaaaa;
            padding: 8px 0;
            text-align: center;
        }

        tr.total td, tr th.total, tr td.total {
        <?php if(!empty($RTL)){?> text-align: left;
        <?php }else{?> text-align: right;
        <?php }?>
        }

        .bg-items {
            background: #6297d9 !important;  /*#515151*/
            color: #FFFFFF
        }

        .p-md {
            padding: 10px !important;
        }

        .left {
        <?php if(!empty($RTL)){?> float: right;
        <?php }else{?> float: left;
        <?php }?>
        }

        .right {
        <?php if(!empty($RTL)){?> float: left;
            padding-right: 20px;
        <?php }else{?> float: right;
            padding-left: 20px;
        <?php }?>
        }
        
        .border {
            border: 1px solid black;
        }

        table.bordered tr td{
            border: 1px solid black;
            padding: 10px;
            font: 16px;
        }

        .bg-items tr th
        {
            border: 1px solid black;
            padding: 10px;
            font: 16px;
        }
    
        @page { margin: 25px; }
        body { padding: 25px; border: 2px solid black; }

        .page_break { page-break-before: always; }
        
        table.scope tr td{
            padding: 7px;
            font: 16px;
        }
    </style>
</head>
<body>

<?php

$img = ROOTPATH . '/' . config_item('company_logo');
$a = file_exists($img);
if (empty($a)) {
    $img = base_url() . config_item('invoice_logo');
}
if (!file_exists($img)) {
    $img = ROOTPATH . '/' . 'uploads/default_logo.png';
}
?>

<header>
    <?= AFMSS ?>
</header>

<footer>
    <p style="margin: 0px;"><?= config_item('company_address') ?></p></br>
    <p style="margin: 0px;"><?= lang('email') ?> : <?= config_item('company_email') ?> , <?= lang('phone')?> : <?= config_item('company_phone') ?></p>
</footer> 

<table class="clearfix">
    <tr style="margin-top: 0px" >
        <td>
            <div id="logo" style="text-align: center;">
                <img style="width: 180px;height: 100px;" src="<?= config_item('company_logo') ?>">
            </div>
        </td>
    </tr>
</table>

<table class="clearfix">
    <tr>
        <td>
            <div>
                <h1 style="text-align: center;color: #6297d9;"><?= config_item('company_name') ?></h1>
                <?php if(config_item('gstin_number')){?><div style="text-align: center;font-size: 18px;">GSTIN : <?= config_item('gstin_number') ?></div><?php }?>
            </div>
        </td>
    </tr>
    <tr style="margin-top: 0px">
        <td>
            <div>
                <h2 style="text-align: center;font-size: 18px;">QUOTATION</h2>            
            </div>
        </td>
    </tr>
    <tr>
        <td>
            <div>
                <p style="margin:0px;"> To,</p>
                <p style="margin:0px;"><?= $client_info->first_name . ' ' . $client_info->middle_name . ' ' . $client_info->last_name;?>
                </p>
                <p style="margin:0px;"><?= $client_info->address ?></p>
                <p> SUBJECT : INSTALLATION OF <?= $client_info->product?> of <?= $requiredKW?> KW CAPACITY </div>
        </td>
    </tr>
</table>
<table class="bordered">
    <?php if($client_info->system_type == 'Mono')
          {
            $rate = $solar_rate_info['mono_rate_per_kw'];
          }
          else if($client_info->system_type == 'Poly A Plus')
          {
            $rate = $solar_rate_info['poly_a_plus_rate_per_kw'];
          }
          else if($client_info->system_type == 'Poly A')
          {
            $rate = $solar_rate_info['poly_a_rate_per_kw'];
          }
    ?>
    <thead class="p-md bg-items">
    <tr>
        <th><?= lang('sr_no')?></th>
        <th><?= lang('system_type')?></th>
        <th><?= lang('rate_per_kw_in_rs')?></th>
        <th><?= lang('system_capacity')?></th>
        <th><?= lang('system_cost')?></th>
    </tr>
</thead>
    <tr>
        <td>1</td>
        <td><?= $client_info->product?></td>
        <td style="text-align: right;"><?= $rate?></td>
        <td style="text-align: right;"><?= $requiredKW ?> KW</td>
        <td style="text-align: right;"><?= $rate*$requiredKW ?></td>
    </tr>
    <tr>
        <td>2</td>
        <td><?= lang('Sanctioning_docc_and_netmetering') ?></td>
        <td style="text-align: right;"><?= $client_info->sanctioning_docc_netmetering ?></td>
        <td style="text-align: right;"><?= $requiredKW ?> KW</td>
        <td style="text-align: right;"><?= $client_info->sanctioning_docc_netmetering * $requiredKW ?></td>
    </tr>
    <tr>
        <td>3</td>
        <td><?= lang('Fabrication') ?></td>
        <td style="text-align: center;">-</td>
        <td style="text-align: center;">-</td>
        <td style="text-align: center;">AT ACTUAL</td>
    </tr>
    <?php $total_cost = ($rate * $requiredKW) + ($client_info->sanctioning_docc_netmetering * $requiredKW);
        if(config_item('company_state')==$client_info->state_id)
        {
            // cgst & sgst
            $sgst_per = config_item('gst_rate_per')/2;
            $cgst_per = config_item('gst_rate_per')/2;
            $sgst_rs = ($total_cost) *($sgst_per)/(100);
            $cgst_rs = ($total_cost) *($cgst_per)/(100); 
            $project_cost = $total_cost+$sgst_rs+$cgst_rs;
        }
        else
        {
            // igst
            $igst_per = config_item('gst_rate_per');
            $igst_rs = ($total_cost) *($igst_per)/(100);
            $project_cost = $total_cost+$igst_rs;
        }
        
         ?>
    <tr>
        <td colspan="2" style="text-align: center;">Total Cost</td>
        <td colspan="3" style="text-align: center;"><?= $total_cost?></td>
    </tr>
    <?php if(config_item('company_state')==$client_info->state_id){?>
    <tr>
        <td colspan="2" style="text-align: center;">SGST <?= config_item('gst_rate_per')/2 ?> %</td>
        <td colspan="3" style="text-align: center;"><?= $sgst_rs?></td>
    </tr>
    <tr>
        <td colspan="2" style="text-align: center;">CGST <?= config_item('gst_rate_per')/2 ?> %</td>
        <td colspan="3" style="text-align: center;"><?= $cgst_rs ?></td>
    </tr>
    <?php }else{?>
    <tr>
        <td colspan="2" style="text-align: center;">IGST <?= config_item('gst_rate_per') ?> %</td>
        <td colspan="3" style="text-align: center;"><?= $igst_rs?></td>
    </tr>
    <?php }?>
    <tr>
        <td colspan="2" style="text-align: center;"><?= lang('project_final_cost')?></td>
        <td colspan="3" style="text-align: center;"><?= $project_cost ?></td>
    </tr>
</table>
<table>
    <tr>
        <td>In Words : <?= $this->client_model->convertNum($project_cost); ?></td>
    </tr>
</table>
<table style="margin-top: 50px;">
    <tr>
        <td>
            <h4 style="text-align: left;margin: 0px;">AUTHORISED SIGNATORY</h4>
            <h4 style="text-align: left;margin: 0px;">(<?= config_item('company_name') ?>)</h4>
        </td>
        <td>
            <h4 style="text-align: left;margin: 0px;"><?= $client_info->first_name . ' ' . $client_info->middle_name . ' ' . $client_info->last_name ?></h4>
            <h4 style="text-align: left;margin: 0px;">(<?= lang('purchaser') ?>)</h4>
        </td>
    </tr>
</table>   
<table class="page_break clearfix">
    <tr>
        <div>
            <p style="margin:0px;">To,</p>
            <p style="margin:0px;"><?= $client_info->first_name . ' ' . $client_info->middle_name . ' ' . $client_info->last_name ?></p>
            <p>Subject : TECHNO-COMMERCIAL OFFER FOR <?= $client_info->product; ?></p>
        </div>
    </tr>
</table>

<table>
    <tr>
        <td>
            <p style="margin-bottom: 0px;">Dear Sir,</p></br>
            <p style="margin-top: 0px;"><?= lang('techno-commercial_sentence') . ' ' . $client_info->product . ' ' . lang('as_follow') ?></p>            
        </td>
    </tr>        
</table>

<table>
    <tr>
        <td>
            <h2 style="font-weight: bold;margin-top:15px;text-decoration: underline;">DATA RECEIVED:</h2>
        </td>
    </tr>
</table>
<table class="bordered">
    <tr>
        <td><?= lang('category'); ?></td>
        <td><?= $client_info->category; ?></td>
    </tr>
    <tr>
        <td><?= lang('consumer_number'); ?></td>
        <td><?= $client_info->consumer_number; ?></td>
    </tr>
    <tr>
        <td><?= lang('load_sanctioned'); ?></td>
        <td><?= $client_info->consumer_number; ?></td>
    </tr>
    <tr>
        <td><?= lang('unit_consumption') . '/' .'day' . ' ' . lang('approx'); ?></td>
        <td><?= $client_info->unit_type=='Monthly' ? (number_format((float)($client_info->units/(30*$client_info->no_of_months)), 2, '.', '')) : (number_format((float)($client_info->units/365), 2, '.', '')) ?></td>
    </tr>

    <tr>
        <td><?= lang('unit_consumption') . '/' .'month' . ' ' . lang('approx'); ?></td>
        <td><?= $client_info->unit_type=='Monthly' ? (number_format((float)($client_info->units/($client_info->no_of_months)), 2, '.', '')) : (number_format((float)($client_info->units/12), 2, '.', '')) ?></td>
    </tr>
    <tr>
        <td><?= lang('unit_consumption') . '/' .'year' . ' ' . lang('approx'); ?></td>
        <td><?= $client_info->unit_type=='Monthly' ? (number_format((float)(($client_info->units/($client_info->no_of_months))*12), 2, '.', '')) : (number_format((float)($client_info->units), 2, '.', '')) ?></td>
    </tr>
    <tr>
        <td><?= lang('mounting'); ?></td>
        <td><?= $client_info->mounting; ?></td>
    </tr>
</table>

<table>
    <tr>
        <td>
            <h2 style="font-weight: bold;margin-top:15px;text-decoration: underline;">SCOPE OF WORK:</h2>
        </td>
    </tr>
</table>

<table class="scope">
    <tr>
        <td style="width: 5%">1</td>
        <td style="width: 50%"><?= lang('solar_panels'); ?></td>
        <td> : <?= $client_info->solar_panels == 1 ? 'Yes' : 'No'; ?></td>
    </tr>
    <tr>
        <td style="width: 5%">2</td>
        <td style="width: 50%"><?= lang('inverter'); ?></td>
        <td> : <?= $client_info->inverter == 1 ? 'Yes' : 'No'; ?></td>
    </tr>
    <tr>
        <td style="width: 5%">3</td>
        <td style="width: 50%"><?= lang('bi_directional_meter'); ?></td>
        <td> : <?= $client_info->bi_directional_meter == 1 ? 'Yes' : 'No';?></td>
    </tr>
    <tr>
        <td style="width: 5%">4</td>
        <td style="width: 50%"><?= lang('battery_backup'); ?></td>
        <td> : <?= $client_info->battery_backup == 1 ? 'Yes' : 'No';?></td>
    </tr>

    <tr>
        <td style="width: 5%">5</td>
        <td style="width: 50%"><?= lang('solar_energy_meter'); ?></td>
        <td> : <?= $client_info->solar_energy_meter == 1 ? 'Yes' : 'No'; ?></td>
    </tr>
    <tr>
        <td style="width: 5%">6</td>
        <td style="width: 50%"><?= lang('accessories_and_electrification'); ?></td>
        <td> : <?= $client_info->accessories_and_electrification == 1 ? 'Yes' : 'No'; ?></td>
    </tr>
    <tr>
        <td style="width: 5%">7</td>
        <td style="width: 50%"><?= lang('installation_and_commissioning'); ?></td>
        <td> : <?= $client_info->installation_and_commissioning == 1 ? 'Yes' : 'No'; ?></td>
    </tr>
    <tr>
        <td style="width: 5%">8</td>
        <td style="width: 50%"><?= lang('sanctioning_and_agreement_sys'); ?></td>
        <td> : <?= $client_info->sanctioning_and_agreement_sys == 1 ? 'Yes' : 'No'; ?></td>
    </tr>
    <tr>
        <td style="width: 5%">9</td>
        <td style="width: 50%"><?= lang('made_a_doccumentation'); ?></td>
        <td> : <?= $client_info->made_a_doccumentation == 1 ? 'Yes' : 'No'; ?></td>
    </tr>
    <tr>
        <td style="width: 5%">10</td>
        <td style="width: 50%"><?= lang('transportation'); ?></td>
        <td> : <?= $client_info->transportation == 1 ? 'Yes' : 'No'; ?></td>
    </tr>
</table> 
<table class="page_break">
    <tr>
        <td><h2 style="font-weight: bold;margin-top:15px;text-decoration: underline;">SYSTEM/DESIGN CONSIDERATION:</h2>
        </td>
    </tr>
    <tr>
        <td>
            <p style="margin-top: 0px;">1 - System Capacity : <?= $requiredKW ?> KW</p>
            <p>2 - Unit generation/day Approx : <?= $sysgenerationinfo['sysgenunitperday']; ?></p>
            <p>3 - Unit generation/Month : <?= $sysgenerationinfo['sysgenunitpermonth']; ?></p>
            <p>4 - Unit generation/year Approx : <?= $sysgenerationinfo['sysgenunitperyear']; ?></p>
        </td>
    </tr>
</table>
<table class="bordered">
    <tr>
        <td colspan="3" style="text-align: center;font-weight: bold;">
            <?= $client_info->product; ?>
        </td>
    </tr>
    <tr>
        <td colspan="3" style="text-align: center;">
            APPROX UNIT GENERATION & PAYBACK PERIOD
        </td>
    </tr>
    <tr>
        <td></td>
        <td>METER-1</td>
        <td rowspan="3">TOTAL</td>
    </tr>
    <tr>
        <td>CATEGORY</td>
        <td><?= $client_info->category; ?></td>
    </tr>
    <tr>
        <td>CONSUMER NO.</td>
        <td><?= $client_info->consumer_number; ?></td>
    </tr>
    <tr>
        <td>SYSTEM PROPOSED (KW)</td>
        <td><?= $requiredKW; ?></td>
        <td><?= $requiredKW; ?></td>
    </tr>
    <tr>
        <td>SYSTEM COST</td>
        <td><?= $project_cost; ?></td>
        <td><?= $project_cost; ?></td>
    </tr>
    <tr>
        <td>SYSTEM GENERATED UNITS/YEAR</td>
        <td><?= $sysgenerationinfo['sysgenunitperyear']; ?></td>
        <td><?= $sysgenerationinfo['sysgenunitperyear']; ?></td>
    </tr>
    <tr>
        <td>APPROX UNIT RATE</td>
        <td><?= $client_info->approx_unit_rate; ?></td>
        <td><?= $client_info->approx_unit_rate; ?></td>
    </tr>
    <tr>
        <td>TOTAL REVENUE GENERATED/YEAR</td>
        <td><?= number_format((float)($sysgenerationinfo['sysgenunitperyear'] * $client_info->approx_unit_rate), 2, '.', ''); ?></td>
        <td><?= number_format((float)($sysgenerationinfo['sysgenunitperyear'] * $client_info->approx_unit_rate), 2, '.', ''); ?></td>        
    </tr>
    <tr>
        <td>APROX PAYBACK YEARS</td>
        <td><?= number_format((float)($project_cost/($sysgenerationinfo['sysgenunitperyear'] * $client_info->approx_unit_rate)), 2, '.', ''); ?></td>
        <td><?= number_format((float)($project_cost/($sysgenerationinfo['sysgenunitperyear'] * $client_info->approx_unit_rate)), 2, '.', ''); ?></td>
    </tr>
    <tr>
        <td colspan="3">
            ** APPROX ELECTRICITY UNIT RATE CONSIDERED BASED ON LAST MONTH BILL.
        </td>
    </tr>
</table>


<table class="page_break">
    <tr>
        <td><h2 style="font-weight: bold;margin-top:15px;text-decoration: underline;">TERMS & CONDITION:</h2>
        </td>
    </tr>
    <tr>
        <td><h3 style="font-weight: bold;margin-top:15px;text-decoration: underline;">PAYMENT TERMS & CONDITIONS:</h3>
        </td>
    </tr>
    <tr>
        <td>
            <p style="margin-top: 0px;">1 - 30% Payment after signing agreement.</p>
            <p>2 - 65% at the time of PO confirmation & MSEB net metering sanction letter.</p>
            <p>3 - 5% after installation.
            </p>
        </td>
    </tr>
    <tr>
        <td><h3 style="font-weight: bold;margin-top:15px;text-decoration: underline;">DELIVERY & INSTALLATION TERMS:</h3>
        </td>
    </tr>
    <tr>
        <td>
            <p style="margin-top: 0px;">1 - 30 Days for MSEB sanction.</p>
            <p>2 - 30 days after receiving 65% of advance payment.</p>
            <p>3 - 30 Days after net metering sanctioning, for installation including trial & training.</p>
        </td>
    </tr>
    <tr>
        <td><h3 style="font-weight: bold;margin-top:15px;text-decoration: underline;">NOTE:</h3>
        </td>
    </tr>
    <tr>
        <td>
            <p style="margin-top: 0px;">1 - All material used is MNRE/MEDA approved.</p>
            <p>2 - Projects under commercial option the subsidy is not given.</p>
            <p>3 - Projects under industrial/commercial category are eligible for tax depreciation.</p>
            <p>4 - Monthly visit of engineer after installation.</p>
        </td>
    </tr>
    <tr>
        <td><h3 style="font-weight: bold;margin-top:15px;text-decoration: underline;">VALIDITY OF OFFER TERMS:</h3>
        </td>
    </tr>
    <tr>
        <td>
            <p style="margin-top: 0px;">1 - This offer is only for 30 days from the date of offer.</p>
        </td>
    </tr>
    <tr>
        <td><h3 style="font-weight: bold;margin-top:15px;text-decoration: underline;">LIMITATION OF LIABLITIES:</h3>
        </td>
    </tr>
    <tr>
        <td>
            <p style="margin-top: 0px;text-align: justify">Our liability in respect of any defect or failure of the equipment supplied there to, is limited to making good by replacing or repairing defects which under proper use appear therein (provided the equipment is installed, operated, maintained as per our instruction manual ) and arise solely from faulty design, materials or workmanship within warrantee period. At the termination of which period, all liability on our part shallcease.</p>
        </td>
    </tr>
    <tr>
        <td><h3 style="font-weight: bold;margin-top:15px;text-decoration: underline;">SOLAR MODULE:</h3>
        </td>
    </tr>
    <tr>
        <td>
            <p style="margin-top: 0px;">1 - 10 Years Limited Warranty on 90% Power Output.</p>
            <p>2 - 15 Years Limited Warranty on 80% Power Output.</p>
        </td>
    </tr>
</table>
<table class="page_break">
    <tr>
        <td><h3 style="font-weight: bold;margin-top:15px;text-decoration: underline;">SOLAR INVERTER:</h3>
        </td>
    </tr>
    <tr>
        <td>
            <p style="margin-top: 0px;">1 - 5 years Limited Warranty on inverter.</p>
            <p>2 - Parts and Components, which are repaired or replaced during such period, are warranted.</p>
            <p>3 - For the original warranty period only and will not carry any extended warranty.</p>
        </td>
    </tr>
    <tr>
        <td><h3 style="font-weight: bold;margin-top:15px;text-decoration: underline;">THE WARRANTY SHALL NOT APPLY TO DEFECTS RESULTING FROM:</h3>
        </td>
    </tr>
    <tr>
        <td>
            <p style="margin-top: 0px;text-align: justify">Willful damage or negligence, normal wear and tear, installation and/or maintenance by purchaser or a third party without supplier’s prior written consent. Misuse or abuse of Equipment. Modifications or alterations made by purchaser or a third party without supplier’s written consent.</p>
        </td>
    </tr>
    <tr>
        <td><h3 style="font-weight: bold;margin-top:15px;text-decoration: underline;">RIGHT AND LIEN OFPROPERTY:</h3>
        </td>
    </tr>
    <tr>
        <td>
            <p style="margin-top: 0px;">We shall retain the right on equipment, material or parts supplied by us under this quotation until full value there of as per our invoice has been fully paid to us as per terms and condition.</p>
        </td>
    </tr>
    <tr>
        <td><h3 style="font-weight: bold;margin-top:15px;text-decoration: underline;">ACCOUNT DETAILS:</h3>
        </td>
    </tr>
    <tr>
        <td>
            <p style="margin-top: 0px;">Name: HDFC BANK LTD.</p>
            <p>Account No: 50200043364862</p>
            <p>Account Type: CURRENT</p>
            <p>IFSC Code: HDFC0000900</p>
        </td>
    </tr>
</table>
<table>
    <tr>
        <td><h3 style="font-weight: bold;margin-top:15px;text-decoration: underline;">REGARDS:</h3>
        </td>
    </tr>
    <tr>
        <td>
            <p style="margin-top: 0px;">For: <?= config_item('company_name'); ?>.</p>
            <p><?= lang('mobile') ?>: <?= config_item('company_phone'); ?></p>
            <p><?= lang('email') ?>: <?= config_item('company_email'); ?></p>
            <p><?= lang('website') ?>: <?= config_item('company_domain'); ?></p>
        </td>
        <td>
            <img style="width: 180px;height: 100px;float: center !important;" src="<?= config_item('company_logo') ?>">
        </td>
    </tr>
</table>

</body>
</html>
