<?= message_box('success'); ?>
<?= message_box('error');
$created = can_action('55', 'created');
$edited = can_action('55', 'edited');
$deleted = can_action('55', 'deleted');
$view = can_action('55', 'view');
$uri_segment = $this->uri->segment(4);

?>

<div class="row">
    <div class="col-sm-12">
        <div class="nav-tabs-custom">
            <div class="tab-content bg-white">
                <!-- ************** general *************-->

            <?= form_open('admin/leads/assign_to_salesperson', 'id="action-form"') ?>
            <?php if (!empty($error)) { ?>
            <div class="alert alert-danger alert-dismissable">
                <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
                <?php echo $error; ?>
            </div>
            <?php 
            } ?>

            <header class="panel-heading" style="border-bottom: 2px solid #2b957a;margin-bottom: 20px;padding: 30px;">
                <div class="form-group">
                    <label class="col-lg-2 control-label"><?= lang('Salesmanager') ?> <span class="text-danger">*</span> 
                    </label>
                    <div class="col-lg-4">
                        <select name="salesmanager_id" class="form-control select_box" style="width: 100%" required="">
                        <option value=""><?= lang('select') . ' ' . lang('Salesmanager') ?></option>
                        <?php
                            if (!empty($salesmanagers)) 
                            {
                                foreach ($salesmanagers as $person) 
                                {
                                    if (!empty($person)) 
                                    {
                        ?>               
                        <option value="<?= $person->user_id ?>" >
                        <?= $person->fullname ?>
                        </option>
                            <?php
                                    }
                                }
                            }
                        ?>
                        </select>                                
                    </div>

                    <div class="col-lg-2">
                        <a data-action="assign" id="assign" style="background-color: #1797be;padding: 4px 14px;" class="btn btn-danger btn-xs ml-lg"><?= lang('assign') ?></a>
                    </div>
                </div>
            </header>
            
            <div class="table-responsive">
                <table class="table table-striped DataTables bulk_table" id="DataTables" cellspacing="0" width="100%">
                    <thead>
                    <tr>
                        <?php if (!empty($deleted)) { ?>
                            <th data-orderable="false">
                                <div class="checkbox c-checkbox">
                                    <label class="needsclick">
                                        <input id="select_all" type="checkbox">
                                        <span class="fa fa-check"></span></label>
                                </div>
                            </th>
                        <?php } ?>
                        <th><?= lang('contact_name') ?></th>
                        <th><?= lang('phone') ?></th>
                        <th><?= lang('city') ?></th>
                        <th><?= lang('address') ?></th>
                        <th><?= lang('lead_status') ?></th>
                        <?php if($this->session->userdata('designations')=='Marketing Head'){?>
                        <th><?= lang('assigned_to') ?></th>
                        <?php }?>
                        <?php if($this->session->userdata('designations')!='Customer Service Executive'){?>
                        <th class="col-options no-sort"><?= lang('action') ?></th>
                        <?php } ?>
                    </tr>
                    </thead>
                    <tbody>
                    </tbody>
                    <script type="text/javascript">
                        $(document).ready(function () {
                            list = base_url + "admin/leads/get_assigned_list";
                        });
                    </script>
                </table>
            </div>

            <div style="display: none;">
                <input type="hidden" name="form_action" value="" id="form_action"/>
                <?= form_submit('submit', 'submit', 'id="action-form-submit"') ?>
            </div>
            <?= form_close() ?>
            </div>
            </div>
        </div>
        
    </div>
</div>

<script type="text/javascript">
    $(document).ready(function () 
    {
        $('#assign').click(function (e) {
            e.preventDefault();
            $('#form_action').val($(this).attr('data-action'));
            $('#action-form-submit').trigger('click');
        });
    });
</script>

