<?= message_box('success'); ?>
<?= message_box('error'); ?>
<div class="panel panel-custom">
    <header class="panel-heading">
        <div class="panel-title"><strong><?= lang('new_leads') ?></strong>      </div>
    </header>
    <div class="panel-body">
        <form role="form" enctype="multipart/form-data" data-parsley-validate="" novalidate=""
              action="<?php echo base_url(); ?>admin/leads/create_leads" method="post"
              class="form-horizontal  ">
            <div class="panel-body">     
                <!-- First Name  -->
                        <div class="form-group">
                            <label class="col-lg-2 control-label"><?= lang('first_name') ?> <span
                                    class="text-danger">*</span></label>
                            <div class="col-lg-4">
                                <input type="text" data-parsley-trigger="keyup"
                                data-parsley-validation-threshold="1" data-parsley-pattern="^[a-zA-Z]+$" class="form-control" value="<?php
                                if (!empty($leads_info)) {
                                    echo $leads_info->first_name;
                                }
                                ?>" name="first_name" required="">
                            </div>

                        <!-- Middle Name  -->
                            <label class="col-lg-2 control-label"><?= lang('middle_name') ?></label>
                            <div class="col-lg-4">
                                <input type="text" data-parsley-trigger="keyup"
                                data-parsley-validation-threshold="1" data-parsley-pattern="^[a-zA-Z]+$" data-parsley-pattern="^[a-zA-Z]+$" class="form-control" value="<?php
                                if (!empty($leads_info)) {
                                    echo $leads_info->middle_name;
                                }
                                ?>" name="middle_name">
                            </div>
                        </div>

                        <div class="form-group">
                            <!-- Last Name  -->
                            <label class="col-lg-2 control-label"><?= lang('last_name') ?> <span
                                    class="text-danger">*</span></label>
                            <div class="col-lg-4">
                                <input type="text" data-parsley-trigger="keyup"
                                data-parsley-validation-threshold="1" data-parsley-pattern="^[a-zA-Z]+$" class="form-control" value="<?php
                                if (!empty($leads_info)) {
                                    echo $leads_info->last_name;
                                }
                                ?>" name="last_name" required="">
                            </div>

                            <!-- Email  -->
                            <label class="col-lg-2 control-label"><?= lang('email') ?> </label>
                            <div class="col-lg-4">
                                <input type="email" data-parsley-type="email" class="form-control" value="<?php
                                if (!empty($leads_info)) {
                                    echo $leads_info->email;
                                }
                                ?>" name="email">
                            </div>
                        </div>

                        <div class="form-group">
                            <!-- Mobile Number  -->
                            <label class="col-lg-2 control-label"><?= lang('mobile') ?><span
                                    class="text-danger">*</span>
                            </label>
                            <div class="col-lg-4">
                                <input type="text" data-parsley-trigger="keyup" data-parsley-validation-threshold="1" data-parsley-debounce="500" 
                                data-parsley-type="digits" 
                                data-parsley-minlength="10" 
                                data-parsley-maxlength="10" required="" class="form-control" value="<?php
                                if (!empty($leads_info)) {
                                    echo $leads_info->mobile;
                                }
                                ?>" name="mobile"/>
                            </div>

                            <!-- Address  -->
                            <label class="col-lg-2 control-label"><?= lang('address') ?> <span
                                    class="text-danger">*</span>
                            </label>
                            <div class="col-lg-4">
                            <textarea name="address" class="form-control" required=""><?php
                                if (!empty($leads_info)) {
                                    echo $leads_info->address;
                                }
                                ?></textarea>
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="col-lg-2 control-label"><?= lang('lead_status') ?> <span
                                    class="text-danger">*</span> 
                            </label>
                            <div class="col-lg-4">
                                <select name="lead_state_id" class="form-control select_box" style="width: 100%" required="" id="lead_state">
                                <option value=""><?= lang('select') . ' ' . lang('state') ?></option>
                                <?php
                                    if (!empty($states)) 
                                    {
                                        foreach ($states as $v_leads_state) 
                                        {
                                            if (!empty($v_leads_state)) 
                                            {
                                    ?>               
                                    <option value="<?= $v_leads_state->id ?>" 
                                    <?php if (!empty($leads_info->lead_state_id))
                                    { 
                                        echo $v_leads_state->id == $leads_info->lead_state_id ? 'selected' : '';
                                    }
                                    ?>>
                                    <?= $v_leads_state->name ?>
                                    </option>
                                    <?php
                                            }
                                        }
                                    }
                                    ?>
                                </select>                                
                            </div>

                            <label class="col-lg-2 control-label"><?= lang('lead_district') ?> <span
                                    class="text-danger">*</span> 
                            </label>
                            <div class="col-lg-4">
                                <select name="lead_district_id" class="form-control select_box"
                                    style="width: 100%" required="" id="lead_district">
                                    <option value=""><?= lang('select') . ' ' . lang('district') ?></option>
                                </select>                                    
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="col-lg-2 control-label"><?= lang('city') ?> <span
                                    class="text-danger">*</span></label>
                            <div class="col-lg-4">
                                <input type="text" class="form-control" value="<?php
                                if (!empty($leads_info)) {
                                    echo $leads_info->city;
                                }
                                ?>" name="city" required="">
                            </div>

                            <label class="col-lg-2 control-label"><?= lang('pincode') ?><span
                                    class="text-danger">*</span>
                            </label>
                            <div class="col-lg-4">
                                <input type="text" data-parsley-trigger="keyup" data-parsley-validation-threshold="1" data-parsley-debounce="500" 
                                data-parsley-type="digits" 
                                data-parsley-minlength="6" 
                                data-parsley-maxlength="6" required="" class="form-control" value="<?php
                                if (!empty($leads_info)) {
                                    echo $leads_info->pincode;
                                }
                                ?>" name="pincode" required=""/>
                            </div>
                        </div>

                        <!-- Lead Category  -->
                        <div class="form-group">
                            <label class="col-lg-2 control-label"><?= lang('lead_categories') ?> 
                            </label>
                            <div class="col-lg-4">
                                <select name="lead_category_id" class="form-control select_box" style="width: 100%" id="lead_category">
                                <option value=""><?= lang('select') . ' ' . lang('lead') . ' ' . lang('category') ?></option>
                                <?php
                                    if (!empty($categories)) 
                                    {
                                        foreach ($categories as $v_leads_categories) 
                                        {
                                            if (!empty($v_leads_categories)) 
                                            {
                                    ?>               
                                    <option value="<?= $v_leads_categories->id ?>" 
                                    <?php if (!empty($leads_info->lead_category))
                                    { 
                                        echo $v_leads_categories->id == $leads_info->lead_category ? 'selected' : '';
                                    }
                                    ?>>
                                    <?= $v_leads_categories->name ?>
                                    </option>
                                    <?php
                                            }
                                        }
                                    }
                                    ?>
                                </select>                                
                            </div>

                            <label class="col-lg-2 control-label"><?= lang('lead_subcategories') ?>  
                            </label>
                            <div class="col-lg-4">
                                <select name="lead_subcategory" class="form-control select_box"
                                    style="width: 100%" id="lead_subcategory">
                                </select>                                    
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="col-lg-2 control-label"><?= lang('lead_product') ?> 
                            </label>
                            <div class="col-lg-4">
                                <select name="lead_product_id" class="form-control select_box" style="width: 100%">
                                <option value=""><?= lang('select') . ' ' . lang('product') ?></option>
                                <?php
                                    if (!empty($products)) 
                                    {
                                        foreach ($products as $v_leads_product) 
                                        {
                                            if (!empty($v_leads_product)) 
                                            {
                                    ?>               
                                    <option value="<?= $v_leads_product->saved_items_id ?>" 
                                    <?php if (!empty($leads_info->lead_product_id))
                                    { 
                                        echo $v_leads_product->saved_items_id == $leads_info->lead_product_id ? 'selected' : '';
                                    }
                                    ?>>
                                    <?= $v_leads_product->item_name ?>
                                    </option>
                                    <?php
                                            }
                                        }
                                    }
                                    ?>
                                </select>                                
                            </div>

                            <label for="field-1" class="col-sm-2 control-label"><?= lang('calculation_type') ?>
                                <span
                                    class="required">*</span></label>
                            <div class="col-sm-4">
                                <div class="checkbox c-radio needsclick">
                                    <label class="needsclick">
                                        <input id="" <?php
                                        if (!empty($leads_info->calculation_type) && $leads_info->calculation_type == 'unit') {
                                            echo 'checked';
                                        } 
                                        ?> type="radio" name="calculation_type" value="unit">
                                        <span class="fa fa-circle"></span><?= lang('unit') ?>
                                    </label>
                               
                                    <label class="needsclick">
                                        <input id="" <?php
                                        if (!empty($leads_info->calculation_type) && $leads_info->calculation_type != 'fileupload') {
                                            echo 'checked';
                                        }
                                        ?> type="radio" name="calculation_type" value="fileupload"
                                        >
                                        <span class="fa fa-circle"></span><?= lang('upload_ele_bill') ?>
                                    </label>
                                </div>
                            </div>
                        </div>

                        <div class="<?php
                            if (!empty($leads_info->calculation_type) && $leads_info->calculation_type != 'unit') {
                            echo 'show';
                            }
                            ?>" id="cal_type">
                        <div class="form-group">
                            
                            <label class="col-lg-2 control-label"><?= lang('consumer_number') ?></label>
                            <div class="col-lg-4">
                                <input type="text" class="form-control" value="<?php
                                if (!empty($leads_info)) {
                                    echo $leads_info->consumer_number;
                                }
                                ?>" name="consumer_number">
                            </div>

                            <label class="col-lg-2 control-label"><?= lang('supplier') ?></label>
                            <div class="col-lg-4">
                                <input type="text" class="form-control" value="<?php
                                if (!empty($leads_info)) {
                                    echo $leads_info->supplier;
                                }
                                ?>" name="supplier">
                            </div>
                        </div>

                        <div class="form-group">                            
                            <label class="col-lg-2 control-label"><?= lang('units') ?> <span
                                    class="text-danger">*</span></label>
                            <div class="col-lg-4">
                                <input type="text" data-parsley-type="digits" class="form-control" value="<?php
                                if (!empty($leads_info)) {
                                    echo $leads_info->units;
                                }
                                ?>" name="units" required="">
                            </div>

                            <label class="col-lg-2 control-label"><?= lang('approximate_unit_rate') ?> <span
                                    class="text-danger">*</span></label>
                            <div class="col-lg-4">
                                <input type="text" class="form-control" value="<?php
                                if (!empty($leads_info)) {
                                    echo $leads_info->approx_unit_rate;
                                }
                                ?>" name="approx_unit_rate" required="">
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="col-lg-2 control-label"><?= lang('unit_type') ?> <span
                                    class="text-danger">*</span></label>
                            <div class="col-sm-4">
                                <div class="checkbox c-radio needsclick">
                                    <label class="needsclick">
                                        <input id="" <?php
                                        if (!empty($leads_info->unit_type) && $leads_info->unit_type == 'Monthly') {
                                            echo 'checked';
                                        } 
                                        ?> type="radio" name="unit_type" value="Monthly">
                                        <span class="fa fa-circle"></span><?= lang('Monthly') ?>
                                    </label>
                               
                                    <label class="needsclick">
                                        <input id="" <?php
                                        if (!empty($leads_info->unit_type) && $leads_info->unit_type != 'Yearly') {
                                            echo 'checked';
                                        }
                                        ?> type="radio" name="unit_type" value="Yearly"
                                        >
                                        <span class="fa fa-circle"></span><?= lang('Yearly') ?>
                                    </label>
                                </div>
                            </div>

                            <div id="months">
                            <label class="col-lg-2 control-label"><?= lang('no_of_months') ?> <span
                                    class="text-danger">*</span></label>
                            <div class="col-lg-4">
                                <input type="text" data-parsley-type="digits" class="form-control" value="<?php
                                if (!empty($leads_info)) {
                                    echo $leads_info->no_of_months;
                                }
                                ?>" name="no_of_months" required="">
                            </div>
                        </div>
                        </div>                       
                    </div>

                    <!-- On click file upload  -->

                    <div class="form-group <?php
                        if (!empty($leads_info->calculation_type) && $leads_info->calculation_type != 'fileupload') {
                        echo 'show';
                        } ?>" id="file_upload">
                        <label class="col-lg-2 control-label"><?= lang('electricity_bill') ?><span class="text-danger">*</span>
                        </label>
                        <div class="col-lg-4">
                            <div class="fileinput fileinput-new" data-provides="fileinput">
                            <div class="fileinput-preview fileinput-exists thumbnail" style="width: 210px;"></div>
                                <div>
                                    <span class="btn btn-default btn-file">
                                        <span class="fileinput-new">
                                            <input type="file" name="attachment" value="upload" data-buttonText="<?= lang('choose_file') ?>" id="ele_bill"/>
                                            <span class="fileinput-exists"><?= lang('change') ?></span>
                                            </span>
                                            <a href="#" class="btn btn-default fileinput-exists"
                                               data-dismiss="fileinput"><?= lang('remove') ?></a>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="form-group">
                    <label class="col-lg-2 control-label"></label>
                    <div class="col-lg-6">
                        <button type="submit" class="btn btn-sm btn-primary"></i> <?= lang('upload') ?></button>
                    </div>
                </div>
                        <!-- <div class="btn-bottom-toolbar text-right">
                            <button type="submit" class="btn btn-sm btn-primary"><?= lang('save') ?>
                            </button>
                        </div>
                        </form> -->
                    </div>
                </div>
            </div>

<script type="text/javascript">
    $(document).ready(function () {
        $('#cal_type').hide();
        $('#file_upload').hide();
        $('#months').hide();
        $("input[name$='calculation_type']").click(function () {
            $("#cal_type").removeClass('show');
            if ($(this).attr("value") == "fileupload") {
                $("#cal_type").hide();
                $("#months").hide();
                $("#file_upload").show();
            } else {
                $("#file_upload").hide();
                $("#months").hide();
                $("#cal_type").show();
            }
        });

        // Hide or show no of months
        $("input[name$='unit_type']").click(function () {
            $("#months").removeClass('show');
            if ($(this).attr("value") == "Monthly") {
                $("#months").show();                
            } else {
                $("#months").hide();
            }
        });
    });




    $('#lead_state').on('change', function () {
        var state_id = $(this).val();
        if (state_id) 
        {
            $.ajax({
                type: 'POST',
                url: '<?= base_url()?>admin/leads/getDistrictByStateId',
                data: 'state_id=' + state_id,
                dataType: "text",
                success: function (data) 
                {
                    $('#lead_district').html('<option value="">Select District</option>');
                    
                    var JSONObject = JSON.parse(data);
                    if (JSONObject) 
                    {
                        for (var key in JSONObject) 
                        {
                            if (JSONObject.hasOwnProperty(key)) 
                            {
                                var option = $('<option />');
                                option.attr('value', JSONObject[key]["id"]).text(JSONObject[key]["name"]);
                                $('#lead_district').append(option);
                            }
                        }
                    } 
                    else 
                    {
                        $('#lead_district').html('<option value="">No District</option>');
                            }
                        }
                    });
                } else {
                    $('#lead_district').html('<option value="">Select State first</option>');

                }
            });

    // Load lead subcategory by category id
    $('#lead_category').on('change', function () {
        var category_id = $(this).val();
        if (category_id) 
        {
            $.ajax({
                type: 'POST',
                url: '<?= base_url()?>admin/leads/getLeadSubcategoriesByCatId',
                data: 'category_id=' + category_id,
                dataType: "text",
                success: function (data) 
                {
                    $('#lead_subcategory').html('<option value="">Select Subcategory</option>');                    
                    var JSONObject = JSON.parse(data);
                    if (JSONObject) 
                    {
                        for (var key in JSONObject) 
                        {
                            if (JSONObject.hasOwnProperty(key)) 
                            {
                                var option = $('<option />');
                                option.attr('value', JSONObject[key]["id"]).text(JSONObject[key]["name"]);
                                $('#lead_subcategory').append(option);
                            }
                        }
                    } 
                    else 
                    {
                        $('#lead_subcategory').html('<option value="">No Subcategory</option>');
                            }
                        }
                    });
                } 
                else
                {
                    $('#lead_subcategory').html('<option value="">Select Lead Category first</option>');
                }
            });
</script>