
<?= message_box('success'); ?>
<?= message_box('error');?>

<div class="row">
    <div class="col-sm-12">
        <div class="panel panel-custom">
            <div class="panel-body">
        <header class="panel-heading" style="border-bottom: 2px solid #2b957a;margin-bottom: 20px;padding-bottom: 70px;">
            <div class="form-group">
                    <div class="col-lg-3">
                        <label class="control-label"><?= lang('salesperson') ?>    <span class="text-danger">*</span> 
                        </label>
                    
                        <select name="salesperson_id" class="form-control select_box" style="width: 100%" required="" id="salesperson">
                        <option value=""><?= lang('select') . ' ' . lang('salesperson') ?></option>
                        <?php
                            if (!empty($salespersons)) 
                            {
                                foreach ($salespersons as $person) 
                                {
                                    if (!empty($person)) 
                                    {
                        ?>               
                        <option value="<?= $person->user_id ?>" >
                        <?= $person->fullname ?>
                        </option>
                        <?php
                            }
                            }
                            }
                        ?>
                        </select>                                
                    </div>

                    <div class="col-lg-3">
                        <label class="control-label"><?= lang('from_date') ?><span class="text-danger">*</span></label>
                        <div class="input-group">
                        <input type="text" name="from_date" class="form-control datepicker" id="from_date" value="<?php
                        if (isset($_POST['from_date'])) 
                        {
                            echo $_POST['from_date'];
                        } 
                        ?>"
                        data-date-format="<?= config_item('date_picker_format'); ?>" required="">
                            <div class="input-group-addon">
                                <a href="#"><i class="fa fa-calendar"></i></a>
                            </div>
                        </div>
                    </div>

                    <div class="col-lg-3">
                        <label class="control-label"><?= lang('to_date') ?><span class="text-danger">*</span></label>
                        <div class="input-group">
                        <input type="text" name="to_date" class="form-control datepicker" id="to_date" value="<?php
                        if (isset($_POST['to_date'])) 
                        {
                            echo $_POST['to_date'];
                        } 
                        ?>"
                        data-date-format="<?= config_item('date_picker_format'); ?>" required="">
                            <div class="input-group-addon">
                                <a href="#"><i class="fa fa-calendar"></i></a>
                            </div>
                        </div>
                    </div>
                    <div class="col-lg-3">
                        <!-- button -->
                        <button type="submit" class="btn btn-sm btn-primary" style="margin-top: 25px;" onclick="getXmlData()"><?= lang('show') ?></button>
                    </div>
                </div>
            </header>
            
            <div class="table-responsive">
                <table class="display compact table table-bordered table-striped" id="dynamic-table">
                            <thead>
                                <tr>
                                    <th>Start Time</th>
                                    <th>End Time</th>
                                    <th>Start Address</th>
                                    <th>End Address</th>
                                    <th>Distance</th>
                                    <th style="min-width:65px; text-align:center;">Action</th>
                                </tr>
                            </thead>
                            <tbody>
                            <tr>
                                <td colspan="11" class="dataTables_empty">No data available in table</td>
                            </tr>
                            </tbody>
                            <tfoot>
                            <tr>
                                <th>Start Time</th>
                                <th>End Time</th>
                                <th>Start Address</th>
                                <th>End Address</th>
                                <th>Distance</th>
                                <th style="min-width:65px; text-align:center;">Action</th>
                             </tr>
                        </tfoot>
                    </table>
            </div>
        </div>
        </div>
    </div>
</div> 
            

<script>
    function separateData(data) {
        var s= data.split(' ');
        var b = s[0].toString().substring(0, s[0].toString().indexOf(".") + 3);      
        return b+' '+s[1];        
    }

    function is_date(d) {
        if (d == '0000-00-00 00:00:00') {
            return '<div class="text-center"><span class="row_status ">---</span></div>';
        } else{
            var s= d.split(' ');
            var p=s[0].split('-');
            var q=s[1].split(':');
            return '<div class="text-left"><span class="row_status ">'+p[2]+'-'+p[1]+'-'+p[0]+' '+q[0]+':'+q[1]+':'+q[2]+'</span></div>';
        }
    }

    function getXmlData()
    {
        var salesman_id= $('#salesperson').val(); 
        var from_date=$('#from_date').val();
        var to_date=$('#to_date').val();
        if(salesman_id && from_date && to_date)
        {
            var oTable = $('#dynamic-table').dataTable({
            "aaSorting": [[2, "asc"]],
            "aLengthMenu": [[10, 25, 50, 100, -1], [10, 25, 50, 100, "All"]],
            "iDisplayLength": 10,
            "bDestroy": true,
            'bProcessing': true, 'bServerSide': false,
            'sAjaxSource': '<?= base_url('admin/location/getXmldatabetweendate/') ?>'+salesman_id+'/'+from_date+'/'+to_date,
            'fnServerData': function (sSource, aoData, fnCallback) {
                aoData.push({
                    "name": "<?= $this->security->get_csrf_token_name() ?>",
                    "value": "<?= $this->security->get_csrf_hash() ?>"
                });
                $.ajax({'dataType': 'json', 'type': 'POST', 'url': sSource, 'data': aoData, 'success': fnCallback});
            }, 
            'fnRowCallback': function (nRow, aData, iDisplayIndex) {
                var oSettings = oTable.fnSettings();
                nRow.id = aData[0];
                nRow.className = "product_link";
                return nRow;
            },
            "aoColumns": [
                {"mRender": is_date},
                {"mRender": is_date},null,null,{"mRender": separateData},null
                ], 'columnDefs': [
                {
                    "targets": 4,
                    "className": "text-right",
                },
                ],"fnFooterCallback": function (nRow, aaData, iStart, iEnd, aiDisplay) {
                }
            });
        }else
            alert("Please select all fields");
        }

</script>



