<?php echo message_box('success'); ?>
<?php echo message_box('error'); ?>

<div class="panel panel-custom">
    <header class="panel-heading ">
        <div class="panel-title"><strong><?= lang('new_supplier') ?></strong></div>
    </header>

    <form enctype="multipart/form-data" id="new_supplier" data-parsley-validate="" novalidate=""
          action="<?php echo base_url('admin/masters/add_new_supplier') ?>" method="post" class="form-horizontal  ">
        <div class="panel-body">
            <div class="form-group">
                <label class="col-lg-3 control-label"><?= lang('name') ?>
                <span class="text-danger">*</span></label>
                <div class="col-lg-5">
                    <input type="text" class="form-control" name="name" required="">
                </div>
            </div>
        
            <input type="hidden" value="Electricity" name="type"/>
            <div class="btn-bottom-toolbar text-right">
                <button type="submit" class="btn btn-sm btn-primary"><?= lang('save') ?></button>
            </div>
        </div>
    </form>
</div>
<script type="text/javascript">
    $(document).on("submit", "form", function (event) {
        var form = $(event.target);
        var id = form.attr('id');
        if (form.attr('action') == '<?= base_url('admin/masters/add_new_supplier')?>') {
            event.preventDefault();
            $.ajax({
                type: form.attr('method'),
                url: form.attr('action'),
                data: form.serialize()
            }).done(function (response) {
                response = JSON.parse(response);
                if (response.status == 'success') {
                    if (typeof (response.id) != 'undefined') {
                        $('#supplier').prepend('<option selected value="' + response.id + '">' + response.name + '</option>');
                        var select2Instance = $('#supplier').data('select2');
                        var resetOptions = select2Instance.options.options;
                        $('#supplier').select2('destroy').select2(resetOptions)
                    }
                }
                toastr[response.status](response.message);
                $('#myModal').modal('hide');
            }).fail(function () {
                console.log('There was a problem with AJAX')
            });
        }
    });

</script>